'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var _extends = require('@babel/runtime/helpers/extends');
var _toConsumableArray = require('@babel/runtime/helpers/toConsumableArray');
var _classCallCheck = require('@babel/runtime/helpers/classCallCheck');
var _createClass = require('@babel/runtime/helpers/createClass');
var _possibleConstructorReturn = require('@babel/runtime/helpers/possibleConstructorReturn');
var _getPrototypeOf = require('@babel/runtime/helpers/getPrototypeOf');
var _inherits = require('@babel/runtime/helpers/inherits');
var React = require('react');
var reactIntl = require('react-intl');
var reactRedux = require('react-redux');
var icons = require('@material-ui/icons');
var feCore = require('@openimis/fe-core');
var redux = require('redux');
var core = require('@material-ui/core');
var AddIcon = require('@material-ui/icons/Add');
var styles$a = require('@material-ui/core/styles');
var _asyncToGenerator = require('@babel/runtime/helpers/asyncToGenerator');
var _regeneratorRuntime = require('@babel/runtime/regenerator');
var _debounce = require('lodash/debounce');
var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var ReplayIcon = require('@material-ui/icons/Replay');
var DeleteIcon = require('@material-ui/icons/Delete');
var VisibilityIcon = require('@material-ui/icons/Visibility');
var VisibilityOffIcon = require('@material-ui/icons/VisibilityOff');
var lab = require('@material-ui/lab');
var Autocomplete = require('@material-ui/lab/Autocomplete');
var TextField = require('@material-ui/core/TextField');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var _extends__default = /*#__PURE__*/_interopDefaultLegacy(_extends);
var _toConsumableArray__default = /*#__PURE__*/_interopDefaultLegacy(_toConsumableArray);
var _classCallCheck__default = /*#__PURE__*/_interopDefaultLegacy(_classCallCheck);
var _createClass__default = /*#__PURE__*/_interopDefaultLegacy(_createClass);
var _possibleConstructorReturn__default = /*#__PURE__*/_interopDefaultLegacy(_possibleConstructorReturn);
var _getPrototypeOf__default = /*#__PURE__*/_interopDefaultLegacy(_getPrototypeOf);
var _inherits__default = /*#__PURE__*/_interopDefaultLegacy(_inherits);
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var AddIcon__default = /*#__PURE__*/_interopDefaultLegacy(AddIcon);
var _asyncToGenerator__default = /*#__PURE__*/_interopDefaultLegacy(_asyncToGenerator);
var _regeneratorRuntime__default = /*#__PURE__*/_interopDefaultLegacy(_regeneratorRuntime);
var _debounce__default = /*#__PURE__*/_interopDefaultLegacy(_debounce);
var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);
var ReplayIcon__default = /*#__PURE__*/_interopDefaultLegacy(ReplayIcon);
var DeleteIcon__default = /*#__PURE__*/_interopDefaultLegacy(DeleteIcon);
var VisibilityIcon__default = /*#__PURE__*/_interopDefaultLegacy(VisibilityIcon);
var VisibilityOffIcon__default = /*#__PURE__*/_interopDefaultLegacy(VisibilityOffIcon);
var Autocomplete__default = /*#__PURE__*/_interopDefaultLegacy(Autocomplete);
var TextField__default = /*#__PURE__*/_interopDefaultLegacy(TextField);

var RIGHT_PRODUCTS = 121001;
var RIGHT_HEALTHFACILITIES = 121101;
var RIGHT_PRICELISTMS = 121201;
var RIGHT_PRICELISTMI = 121301;
var RIGHT_MEDICALSERVICES = 121401;
var RIGHT_MEDICALITEMS = 122101;
var RIGHT_ENROLMENTOFFICER = 121501;
var RIGHT_CLAIMADMINISTRATOR = 121601;
var RIGHT_LOCATIONS = 121901;
var RIGHT_USERS = 121701;
var RIGHT_USER_ADD = 121702;
var RIGHT_USER_EDIT = 121703;
var RIGHT_USER_DELETE = 121704;
var INTERACTIVE_USER_TYPE = "INTERACTIVE";
var ENROLMENT_OFFICER_USER_TYPE = "OFFICER";
var OFFICER_ROLE_IS_SYSTEM = 1;
var CLAIM_ADMIN_USER_TYPE = "CLAIM_ADMIN";
var CLAIM_ADMIN_IS_SYSTEM = 256;
var MODULE_NAME = "user";
var DEFAULT = {
  RENDER_LAST_NAME_FIRST: true
};

// https://html.spec.whatwg.org/multipage/input.html#valid-e-mail-address
var EMAIL_REGEX_PATTERN = /^[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$/;
var USER_TYPES = function USER_TYPES(rights) {
  var baseTypes = [INTERACTIVE_USER_TYPE];
  if (rights.includes(RIGHT_ENROLMENTOFFICER)) {
    baseTypes.push(ENROLMENT_OFFICER_USER_TYPE);
    if (rights.includes(RIGHT_CLAIMADMINISTRATOR)) {
      baseTypes.push(CLAIM_ADMIN_USER_TYPE);
    }
  }
  return baseTypes;
};

function _callSuper$4(t, o, e) { return o = _getPrototypeOf__default["default"](o), _possibleConstructorReturn__default["default"](t, _isNativeReflectConstruct$4() ? Reflect.construct(o, e || [], _getPrototypeOf__default["default"](t).constructor) : o.apply(t, e)); }
function _isNativeReflectConstruct$4() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct$4 = function _isNativeReflectConstruct() { return !!t; })(); }
var ADMIN_MAIN_MENU_CONTRIBUTION_KEY = "admin.MainMenu";
var ADMIN_VOUCHER_MAIN_MENU_CONTRIBUTION_KEY = "admin.voucher.MainMenu";
var AdminMainMenu = /*#__PURE__*/function (_Component) {
  function AdminMainMenu(props) {
    var _this;
    _classCallCheck__default["default"](this, AdminMainMenu);
    _this = _callSuper$4(this, AdminMainMenu, [props]);
    _this.isWorker = props.modulesManager.getConf("fe-core", "isWorker", false);
    return _this;
  }
  _inherits__default["default"](AdminMainMenu, _Component);
  return _createClass__default["default"](AdminMainMenu, [{
    key: "render",
    value: function render() {
      var rights = this.props.rights;
      var entries = [];
      if (this.isWorker) {
        if (rights.includes(RIGHT_USERS)) {
          entries.push({
            text: feCore.formatMessage(this.props.intl, "admin", "menu.users"),
            icon: /*#__PURE__*/React__default["default"].createElement(icons.Person, null),
            route: "/admin/users"
          });
        }
        entries.push.apply(entries, _toConsumableArray__default["default"](this.props.modulesManager.getContribs(ADMIN_VOUCHER_MAIN_MENU_CONTRIBUTION_KEY).filter(function (c) {
          return !c.filter || c.filter(rights);
        })));
        if (!entries.length) return null;
        return /*#__PURE__*/React__default["default"].createElement(feCore.MainMenuContribution, _extends__default["default"]({}, this.props, {
          header: feCore.formatMessage(this.props.intl, "admin", "mainMenu"),
          icon: /*#__PURE__*/React__default["default"].createElement(icons.LocationCity, null),
          entries: entries
        }));
      }
      if (rights.includes(RIGHT_PRODUCTS)) {
        entries.push({
          text: feCore.formatMessage(this.props.intl, "admin", "menu.products"),
          icon: /*#__PURE__*/React__default["default"].createElement(icons.Tune, null),
          route: "/admin/products"
        });
      }
      if (rights.includes(RIGHT_HEALTHFACILITIES)) {
        entries.push({
          text: feCore.formatMessage(this.props.intl, "admin", "menu.healthFacilities"),
          icon: /*#__PURE__*/React__default["default"].createElement(icons.LocalHospital, null),
          route: "/location/healthFacilities",
          withDivider: true
        });
      }
      if (rights.includes(RIGHT_PRICELISTMS)) {
        entries.push({
          text: feCore.formatMessage(this.props.intl, "admin", "menu.medicalServicesPrices"),
          icon: /*#__PURE__*/React__default["default"].createElement(icons.HealingOutlined, null),
          route: "/medical/pricelists/services"
        });
      }
      if (rights.includes(RIGHT_PRICELISTMI)) {
        entries.push({
          text: feCore.formatMessage(this.props.intl, "admin", "menu.medicalItemsPrices"),
          icon: /*#__PURE__*/React__default["default"].createElement(icons.LocalPharmacyOutlined, null),
          route: "/medical/pricelists/items",
          withDivider: true
        });
      }
      if (rights.includes(RIGHT_MEDICALSERVICES)) {
        entries.push({
          text: feCore.formatMessage(this.props.intl, "admin", "menu.medicalServices"),
          icon: /*#__PURE__*/React__default["default"].createElement(icons.Healing, null),
          route: "/medical/medicalServices"
        });
      }
      if (rights.includes(RIGHT_MEDICALITEMS)) {
        entries.push({
          text: feCore.formatMessage(this.props.intl, "admin", "menu.medicalItems"),
          icon: /*#__PURE__*/React__default["default"].createElement(icons.LocalPharmacy, null),
          route: "/medical/medicalItems",
          withDivider: true
        });
      }
      if (rights.includes(RIGHT_USERS)) {
        entries.push({
          text: feCore.formatMessage(this.props.intl, "admin", "menu.users"),
          icon: /*#__PURE__*/React__default["default"].createElement(icons.Person, null),
          route: "/admin/users"
        });
      }
      if (rights.includes(RIGHT_LOCATIONS)) {
        entries.push({
          text: feCore.formatMessage(this.props.intl, "admin", "menu.locations"),
          icon: /*#__PURE__*/React__default["default"].createElement(icons.PinDrop, null),
          route: "/location/locations"
        });
      }
      entries.push.apply(entries, _toConsumableArray__default["default"](this.props.modulesManager.getContribs(ADMIN_MAIN_MENU_CONTRIBUTION_KEY).filter(function (c) {
        return !c.filter || c.filter(rights);
      })));
      if (!entries.length) return null;
      return /*#__PURE__*/React__default["default"].createElement(feCore.MainMenuContribution, _extends__default["default"]({}, this.props, {
        header: feCore.formatMessage(this.props.intl, "admin", "mainMenu"),
        icon: /*#__PURE__*/React__default["default"].createElement(icons.LocationCity, null),
        entries: entries
      }));
    }
  }]);
}(React.Component);
var mapStateToProps$4 = function mapStateToProps(state) {
  return {
    rights: !!state.core && !!state.core.user && !!state.core.user.i_user ? state.core.user.i_user.rights : []
  };
};
var AdminMainMenu$1 = feCore.withModulesManager(reactIntl.injectIntl(reactRedux.connect(mapStateToProps$4)(AdminMainMenu)));

function ownKeys$7(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$7(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$7(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$7(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var addUserType = function addUserType(user, userType) {
  if (!user.userTypes.includes(userType)) {
    user.userTypes = [].concat(_toConsumableArray__default["default"](user.userTypes), [userType]);
  }
};
function checkRolesAndGetUserTypes(user) {
  var _tempUser$roles, _tempUser$roles2;
  if (!user) return console.warn("User not provided in checkRolesAndGetUserTypes function!");
  var tempUser = user;
  var initialUserTypes = [INTERACTIVE_USER_TYPE];
  if (!tempUser.roles) {
    tempUser.userTypes = initialUserTypes;
  }
  if ((_tempUser$roles = tempUser.roles) !== null && _tempUser$roles !== void 0 && _tempUser$roles.some(function (role) {
    return role.isSystem === CLAIM_ADMIN_IS_SYSTEM;
  })) {
    addUserType(tempUser, CLAIM_ADMIN_USER_TYPE);
  }
  if ((_tempUser$roles2 = tempUser.roles) !== null && _tempUser$roles2 !== void 0 && _tempUser$roles2.some(function (role) {
    return role.isSystem === OFFICER_ROLE_IS_SYSTEM;
  })) {
    addUserType(tempUser, ENROLMENT_OFFICER_USER_TYPE);
  }
  return tempUser.userTypes;
}
var mapQueriesUserToStore = function mapQueriesUserToStore(u) {
  // TODO: make this more generic
  u.hasLogin = false;
  u.userTypes = checkRolesAndGetUserTypes(u);
  if (u.iUser) {
    u.hasLogin = true;
    u.lastName = u.iUser.lastName;
    u.otherNames = u.iUser.otherNames;
    u.email = u.iUser.email;
    u.phoneNumber = u.iUser.phone;
    u.healthFacility = u.iUser.healthFacility;
    u.language = u.iUser.languageId;
    u.roles = u.iUser.roles;
    u.districts = u.iUser.districts.map(function (d) {
      return d.location;
    });
  }
  if (u.claimAdmin) {
    var _u$email;
    u.hasLogin = u.hasLogin || u.claimAdmin.hasLogin;
    u.lastName = u.claimAdmin.lastName;
    u.otherNames = u.claimAdmin.otherNames;
    u.email = (_u$email = u.email) !== null && _u$email !== void 0 ? _u$email : u.claimAdmin.emailId;
    u.phoneNumber = u.claimAdmin.phone;
    u.birthDate = u.claimAdmin.dob;
    u.healthFacility = u.claimAdmin.healthFacility;
  }
  if (u.officer) {
    var _u$email2;
    u.hasLogin = u.hasLogin || u.officer.hasLogin;
    u.lastName = u.officer.lastName;
    u.otherNames = u.officer.otherNames;
    u.email = (_u$email2 = u.email) !== null && _u$email2 !== void 0 ? _u$email2 : u.officer.email;
    u.phoneNumber = u.officer.phone;
    u.birthDate = u.officer.dob;
    u.address = u.officer.address;
    u.substitutionOfficer = u.officer.substitutionOfficer;
    // substitutionOfficer is user.officer so it cannot be retrieved using the UserPicker
    u.worksTo = u.officer.worksTo;
    u.location = u.officer.location;
    u.officerVillages = u.officer.officerVillages.map(function (x) {
      return x.location;
    });
  }
  return u;
};
var mapUserValuesToInput = function mapUserValuesToInput(values) {
  var _values$substitutionO, _values$officerVillag;
  var input = {
    uuid: values.id ? feCore.decodeId(values.id) : null,
    username: values.username,
    userTypes: values.userTypes,
    lastName: values.lastName,
    otherNames: values.otherNames,
    phone: values.phoneNumber,
    email: values.email,
    password: values.password,
    healthFacilityId: values.healthFacility ? feCore.decodeId(values.healthFacility.id) : null,
    districts: values.districts.map(function (d) {
      return feCore.decodeId(d.id);
    }),
    locationId: values.location ? feCore.decodeId(values.location.id) : null,
    language: values.language,
    roles: values.roles.map(function (r) {
      return feCore.decodeId(r.id);
    }),
    birthDate: values.birthDate,
    address: values.address,
    substitutionOfficerId: (_values$substitutionO = values.substitutionOfficer) !== null && _values$substitutionO !== void 0 && _values$substitutionO.id ? feCore.decodeId(values.substitutionOfficer.id) : null,
    worksTo: values.worksTo,
    villageIds: (_values$officerVillag = values.officerVillages) === null || _values$officerVillag === void 0 ? void 0 : _values$officerVillag.map(function (location) {
      return feCore.decodeId(location.id);
    })
  };
  return input;
};
var toggleUserType = function toggleUserType(user, type) {
  if (!user.userTypes) {
    user.userTypes = [];
  }
  if (user.userTypes.includes(type)) {
    user.userTypes = user.userTypes.filter(function (x) {
      return x !== type;
    });
  } else {
    user.userTypes.push(type);
  }
  return user;
};
var toggleUserRoles = function toggleUserRoles(edited, data, isValid, isEnabled, hasRole, onEditedChanged, roleIsSystem) {
  var _edited$roles, _data$role$edges;
  var roles = (_edited$roles = edited === null || edited === void 0 ? void 0 : edited.roles) !== null && _edited$roles !== void 0 ? _edited$roles : [];
  var role = data === null || data === void 0 || (_data$role$edges = data.role.edges) === null || _data$role$edges === void 0 ? void 0 : _data$role$edges[0].node;
  if (isValid && isEnabled && !hasRole) {
    roles.push(role);
    edited.roles = roles;
    onEditedChanged(_objectSpread$7({}, edited));
  } else if (isValid && !isEnabled) {
    var filteredRoles = roles.filter(function (tempRole) {
      return tempRole.isSystem !== roleIsSystem;
    });
    edited.roles = filteredRoles;
    onEditedChanged(_objectSpread$7({}, edited));
  }
};
var toggleSwitchButton = function toggleSwitchButton(edited, hasRole, hasUserType, setIsEnabled, onEditedChanged, userType) {
  if (hasRole) {
    setIsEnabled(function () {
      return true;
    });
    onEditedChanged(toggleUserType(edited, userType));
  } else {
    setIsEnabled(function () {
      return false;
    });
    if (hasUserType) {
      onEditedChanged(toggleUserType(edited, userType));
    }
  }
};
var fetchSubstitutionEOs = function fetchSubstitutionEOs(dispatch, mm, officerUuid, searchString, villages) {
  dispatch(fetchSubstitutionEnrolmentOfficers(mm, {
    officerUuid: officerUuid,
    first: searchString ? undefined : 15,
    villagesUuids: villages === null || villages === void 0 ? void 0 : villages.map(function (village) {
      return village.uuid;
    }),
    str: searchString
  }));
};

var USER_SUMMARY_PROJECTION = ["id", "username", "officer{id,dob,phone,lastName,otherNames,email}", "iUser{id,phone,lastName,otherNames,email,roles{id,name}}", "claimAdmin{id,phone,lastName,otherNames,emailId,dob}", "validityTo", "clientMutationId"];
var DISTRICT_DATA_FETCH_PARAMS = "id, uuid, code, name, parent { id, uuid, name, code }";
var USER_PICKER_PROJECTION = ["id", "username", "iUser{id otherNames lastName}"];
function fetchUsers(mm) {
  var filters = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var restrictHealthFacility = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  return function (dispatch, getState) {
    if (restrictHealthFacility) {
      var state = getState();
      var hf = state.loc.userHealthFacilityFullPath;
      if (hf) {
        filters.push("healthFacility_Uuid: \"".concat(hf.uuid, "\""));
      }
    }
    var payload = feCore.formatPageQuery("users", filters, mm.getRef("admin.UserPicker.projection"));
    return dispatch(feCore.graphql(payload, "ADMIN_USERS", filters));
  };
}
function fetchUsersSummaries(mm, filters) {
  var payload = feCore.formatPageQueryWithCount("users", filters, USER_SUMMARY_PROJECTION);
  return feCore.graphql(payload, "ADMIN_USERS_SUMMARIES");
}
function fetchEnrolmentOfficers(mm, variables) {
  return feCore.graphqlWithVariables("\n      query ($searchString: String, $first: Int) {\n        enrolmentOfficers(str: $searchString, first: $first) {\n          edges {\n            node {\n              id\n              code\n              lastName\n              otherNames\n\n            }\n          }\n          pageInfo {\n            hasNextPage\n          }\n        }\n      }\n    ", variables, "ADMIN_ENROLMENT_OFFICERS");
}
function fetchSubstitutionEnrolmentOfficers(mm, variables) {
  return feCore.graphqlWithVariables("\n      query SubstitutionEnrolmentOfficers ($str: String, $villagesUuids: [String!], $officerUuid: String) {\n        substitutionEnrolmentOfficers(str: $str, villagesUuids: $villagesUuids, officerUuid: $officerUuid) {\n          edges {\n            node {\n              id\n              uuid\n              code\n              lastName\n              otherNames\n            }\n          }\n        }\n      }\n    ", variables, "ADMIN_SUBSTITUTION_ENROLMENT_OFFICERS");
}
function createUser(mm, user, clientMutationLabel) {
  var mutation = feCore.prepareMutation("\n    mutation ($input: CreateUserMutationInput!) {\n      createUser(input: $input) {\n        clientMutationId\n        internalId\n      }\n    }\n  ", mapUserValuesToInput(user), {
    clientMutationLabel: clientMutationLabel
  });

  // eslint-disable-next-line no-param-reassign
  user.clientMutationId = mutation.clientMutationId;
  return feCore.graphqlWithVariables(mutation.operation, mutation.variables, ["ADMIN_USER_MUTATION_REQ", "ADMIN_USER_CREATE_RESP", "ADMIN_USER_MUTATION_ERR"], {
    clientMutationId: mutation.clientMutationId,
    clientMutationLabel: clientMutationLabel
  });
}
function updateUser(mm, user, clientMutationLabel) {
  var mutation = feCore.prepareMutation("\n    mutation ($input: UpdateUserMutationInput!) {\n      updateUser(input: $input) {\n        clientMutationId\n        internalId\n      }\n    }\n  ", mapUserValuesToInput(user), {
    clientMutationLabel: clientMutationLabel
  });

  // eslint-disable-next-line no-param-reassign
  user.clientMutationId = mutation.clientMutationId;
  return feCore.graphqlWithVariables(mutation.operation, mutation.variables, ["ADMIN_USER_MUTATION_REQ", "ADMIN_USER_UPDATE_RESP", "ADMIN_USER_MUTATION_ERR"], {
    clientMutationId: mutation.clientMutationId,
    clientMutationLabel: clientMutationLabel,
    userId: user.id
  });
}
function deleteUser(mm, user, clientMutationLabel) {
  var mutation = feCore.formatMutation("deleteUser", "uuids: [\"".concat(feCore.decodeId(user.id), "\"]"), clientMutationLabel);
  // eslint-disable-next-line no-param-reassign
  user.clientMutationId = mutation.clientMutationId;
  return function (dispatch) {
    dispatch(feCore.graphql(mutation.payload, ["ADMIN_USER_MUTATION_REQ", "ADMIN_USER_DELETE_RESP", "ADMIN_USER_MUTATION_ERR"], {
      clientMutationId: mutation.clientMutationId,
      clientMutationLabel: clientMutationLabel,
      userId: user.id
    }));
    dispatch(feCore.fetchMutation(mutation.clientMutationId));
  };
}
function fetchUser(mm, userId, clientMutationId) {
  var filters = [];
  if (userId) {
    filters.push("id: \"".concat(feCore.decodeId(userId), "\""));
    filters.push("showDeleted: true");
  } else if (clientMutationId) {
    filters.push("clientMutationId: \"".concat(clientMutationId, "\""));
  }
  return feCore.graphql("\n    {\n      users(".concat(filters.join(" "), ") {\n        pageInfo { hasNextPage, hasPreviousPage, startCursor, endCursor}\n        edges {\n          node {\n            clientMutationId\n            id\n            username\n            validityTo\n            officer {\n              id\n              uuid\n              hasLogin\n              phone\n              dob\n              lastName\n              otherNames\n              address\n              substitutionOfficer { id lastName otherNames code }\n              worksTo\n              officerVillages {\n                id\n                location {\n                  id\n                  name\n                  code\n                  uuid\n                  parent {\n                    id\n                    name\n                    code\n                    uuid\n                  }\n                }\n              }\n              location {\n                id\n                name\n                uuid\n                code\n                parent {\n                  id\n                  name\n                  uuid\n                  code\n                }\n              }\n            }\n            iUser {\n              id\n              phone\n              languageId\n              lastName\n              otherNames\n              roles { id name isSystem}\n              healthFacility ").concat(mm.getProjection("location.HealthFacilityPicker.projection"), "\n              validityFrom\n              validityTo\n              email\n              districts: userdistrictSet { location { id name code uuid parent { id code uuid name }}}\n            }\n            claimAdmin{\n              id\n              hasLogin\n              emailId\n              phone\n              dob\n              lastName\n              otherNames\n              healthFacility ").concat(mm.getProjection("location.HealthFacilityPicker.projection"), "\n\n            }\n          }\n        }\n      }\n    }\n  "), "ADMIN_USER_OVERVIEW");
}
function fetchUserMutation(mm, clientMutationId) {
  var payload = feCore.formatPageQuery("mutationLogs", ["clientMutationId:\"".concat(clientMutationId, "\"")], ["id", "status", "users{coreUser{id}}"]);
  return feCore.graphql(payload, "ADMIN_USER");
}
function fetchRegionDistricts(parent) {
  var filters = ["type: \"D\""];
  if (parent) {
    filters.push("parent_Uuid: \"".concat(parent.uuid, "\""));
  }
  var payload = feCore.formatPageQuery("locations", filters, ["id", "uuid", "type", "code", "name", "malePopulation", "femalePopulation", "otherPopulation", "families", "clientMutationId"]);
  return feCore.graphql(payload, "LOCATION_REGION_DISTRICTS");
}
function fetchDataFromDistrict(districtUuids) {
  var filters = [];
  if (districtUuids) {
    filters.push("parent_Uuid_In: [\"".concat(districtUuids.join('", "'), "\"]"));
  }
  var payload = feCore.formatPageQuery("locations", filters, ["".concat(DISTRICT_DATA_FETCH_PARAMS, ", children { edges {node {").concat(DISTRICT_DATA_FETCH_PARAMS, "}}}")]);
  return feCore.graphql(payload, "LOCATION_DISTRICT_DATA");
}
function fetchObligatoryUserFields() {
  var payload = "query userObligatoryFields {userObligatoryFields}";
  return feCore.graphql(payload, "OBLIGTORY_USER_FIELDS");
}
function fetchObligatoryEnrolmentOfficerFields() {
  var payload = "query userObligatoryFields {eoObligatoryFields}";
  return feCore.graphql(payload, "OBLIGTORY_EO_FIELDS");
}
function clearDistrictData() {
  return function (dispatch) {
    dispatch({
      type: "LOCATION_DISTRICT_DATA_CLEAR"
    });
  };
}
function usernameValidationCheck(mm, variables) {
  return feCore.graphqlWithVariables("\n    query ($username: String!) {\n      isValid: validateUsername(username: $username)\n    }\n    ", variables, "USERNAME_FIELDS_VALIDATION");
}
function fetchUsernameLength() {
  var payload = "query {usernameLength}";
  return feCore.graphql(payload, "USERNAME_LENGTH_FIELDS");
}
function usernameValidationClear() {
  return function (dispatch) {
    dispatch({
      type: "USERNAME_FIELDS_VALIDATION_CLEAR"
    });
  };
}
function setUsernameValid() {
  return function (dispatch) {
    dispatch({
      type: "USERNAME_FIELDS_VALIDATION_SET_VALID"
    });
  };
}
function clearUser() {
  return function (dispatch) {
    dispatch({
      type: "ADMIN_USER_OVERVIEW_CLEAR"
    });
  };
}
function userEmailValidationCheck(mm, variables) {
  return feCore.graphqlWithVariables("\n    query ($userEmail: String!) {\n      isValid: validateUserEmail(userEmail: $userEmail)\n    }\n    ", variables, "USER_EMAIL_FIELDS_VALIDATION");
}
function userEmailValidationClear() {
  return function (dispatch) {
    dispatch({
      type: "USER_EMAIL_FIELDS_VALIDATION_CLEAR"
    });
  };
}
function setUserEmailValid() {
  return function (dispatch) {
    dispatch({
      type: "USER_EMAIL_FIELDS_VALIDATION_SET_VALID"
    });
  };
}
function saveEmailFormatValidity(isFormatInvalid) {
  return function (dispatch) {
    dispatch({
      type: "USER_EMAIL_FORMAT_VALIDATION_CHECK",
      payload: {
        data: {
          isFormatInvalid: isFormatInvalid
        }
      }
    });
  };
}

function ownKeys$6(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$6(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$6(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$6(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _callSuper$3(t, o, e) { return o = _getPrototypeOf__default["default"](o), _possibleConstructorReturn__default["default"](t, _isNativeReflectConstruct$3() ? Reflect.construct(o, e || [], _getPrototypeOf__default["default"](t).constructor) : o.apply(t, e)); }
function _isNativeReflectConstruct$3() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct$3 = function _isNativeReflectConstruct() { return !!t; })(); }
var styles$9 = function styles(theme) {
  return {
    dialogTitle: theme.dialog.title,
    dialogContent: theme.dialog.content,
    form: {
      padding: "0 0 10px 0",
      width: "100%"
    },
    item: {
      padding: theme.spacing(1)
    },
    paperDivider: theme.paper.divider
  };
};
var extractLocations = function extractLocations(locations) {
  var locationsArray = Object.values(locations).map(function (l) {
    return l.value;
  });
  var region = locationsArray.find(function (l) {
    return !l.parent;
  });
  var district = region && locationsArray.find(function (l) {
    return l.parent && l.parent.id === region.id;
  });
  var municipality = district && locationsArray.find(function (l) {
    return l.parent && l.parent.id === district.id;
  });
  var village = municipality && locationsArray.find(function (l) {
    return l.parent && l.parent.id === municipality.id;
  });
  return {
    region: region,
    district: district,
    municipality: municipality,
    village: village
  };
};
var getParentLocation = function getParentLocation(locations) {
  var extractedLocations = extractLocations(locations);
  var region = extractedLocations.region,
    district = extractedLocations.district,
    municipality = extractedLocations.municipality,
    village = extractedLocations.village;
  if (!region) {
    return null;
  }
  var newLocation = {
    key: "regionId",
    id: feCore.decodeId(region.id),
    value: region
  };
  if (district) {
    newLocation = {
      key: "districtId",
      id: feCore.decodeId(district.id),
      value: district
    };
  }
  if (municipality) {
    newLocation = {
      key: "municipalityId",
      id: feCore.decodeId(municipality.id),
      value: municipality
    };
  }
  if (village) {
    newLocation = {
      key: "villageId",
      id: feCore.decodeId(village.id),
      value: village
    };
  }
  return newLocation;
};
var UserFilter = /*#__PURE__*/function (_Component) {
  function UserFilter(props) {
    var _this;
    _classCallCheck__default["default"](this, UserFilter);
    _this = _callSuper$3(this, UserFilter, [props]);
    _defineProperty__default["default"](_this, "state", {
      locationFilters: {},
      selectedDistrict: {}
    });
    _defineProperty__default["default"](_this, "debouncedOnChangeFilter", _debounce__default["default"](_this.props.onChangeFilters, _this.props.modulesManager.getConf("fe-admin", "debounceTime", 200)));
    _defineProperty__default["default"](_this, "filterValue", function (k) {
      var filters = _this.props.filters;
      return !!filters && !!filters[k] ? filters[k].value : null;
    });
    _defineProperty__default["default"](_this, "filterTextFieldValue", function (k) {
      var filters = _this.props.filters;
      return !!filters && !!filters[k] ? filters[k].value : "";
    });
    _defineProperty__default["default"](_this, "filterDistrict", function (locations) {
      var extractedLocations = extractLocations(locations);
      var district = extractedLocations.district;
      return district;
    });
    _defineProperty__default["default"](_this, "onChangeCheckbox", function (key, value) {
      var filters = [{
        id: key,
        value: value,
        filter: "".concat(key, ": ").concat(value)
      }];
      _this.props.onChangeFilters(filters);
    });
    _defineProperty__default["default"](_this, "onChangeUserTypes", function (currentUserType) {
      var onChangeFilters = _this.props.onChangeFilters;
      onChangeFilters([{
        id: "userTypes",
        value: currentUserType,
        filter: currentUserType ? "userTypes: [".concat(currentUserType, "]") : []
      }]);
    });
    _defineProperty__default["default"](_this, "onChangeUserRoles", function (currentUserRoles) {
      var onChangeFilters = _this.props.onChangeFilters;
      _this.setState({
        currentUserRoles: currentUserRoles
      });
      onChangeFilters([{
        id: "roles",
        value: currentUserRoles,
        filter: currentUserRoles ? "roles: [".concat(currentUserRoles.map(function (ur) {
          return feCore.decodeId(ur.id);
        }).join(","), "]") : []
      }]);
    });
    _defineProperty__default["default"](_this, "onChangeLocation", function (newLocationFilters) {
      var onChangeFilters = _this.props.onChangeFilters;
      var locationFilters = _objectSpread$6({}, _this.state.locationFilters);
      newLocationFilters.forEach(function (filter) {
        if (filter.value === null) {
          delete locationFilters[filter.id];
        } else {
          locationFilters[filter.id] = {
            value: filter.value,
            filter: filter.filter
          };
        }
      });
      var selectedDistrict = _this.filterDistrict(locationFilters);
      _this.setState({
        locationFilters: locationFilters,
        selectedDistrict: selectedDistrict
      });
      var parentLocation = getParentLocation(locationFilters);
      var filters = [{
        id: "parentLocation",
        filter: parentLocation && "".concat(parentLocation.key, ": ").concat(parentLocation.id)
      }];
      onChangeFilters(filters);
    });
    _defineProperty__default["default"](_this, "renderLastNameField", function (classes) {
      return /*#__PURE__*/React__default["default"].createElement(feCore.ControlledField, {
        module: "admin",
        id: "userFilter.LastName",
        field: /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
          module: "user",
          label: "admin.user.lastName",
          name: "lastName",
          value: _this.filterTextFieldValue("lastName"),
          onChange: function onChange(v) {
            return _this.debouncedOnChangeFilter([{
              id: "lastName",
              value: v,
              filter: "lastName: \"".concat(v, "\"")
            }]);
          }
        }))
      });
    });
    _defineProperty__default["default"](_this, "renderGivenNameField", function (classes) {
      return /*#__PURE__*/React__default["default"].createElement(feCore.ControlledField, {
        module: "admin",
        id: "userFilter.OtherNames",
        field: /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
          module: "user",
          label: "admin.user.otherNames",
          name: "otherNames",
          value: _this.filterTextFieldValue("otherNames"),
          onChange: function onChange(v) {
            return _this.debouncedOnChangeFilter([{
              id: "otherNames",
              value: v,
              filter: "otherNames: \"".concat(v, "\"")
            }]);
          }
        }))
      });
    });
    _this.renderLastNameFirst = props.modulesManager.getConf("fe-insuree", "renderLastNameFirst", DEFAULT.RENDER_LAST_NAME_FIRST);
    return _this;
  }
  _inherits__default["default"](UserFilter, _Component);
  return _createClass__default["default"](UserFilter, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props = this.props,
        classes = _this$props.classes,
        filters = _this$props.filters,
        onChangeFilters = _this$props.onChangeFilters,
        intl = _this$props.intl;
      var _this$state = this.state;
        _this$state.locationFilters;
        _this$state.currentUserType;
        _this$state.currentUserRoles;
        var selectedDistrict = _this$state.selectedDistrict;
      return /*#__PURE__*/React__default["default"].createElement("section", {
        className: classes.form
      }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
        container: true
      }, /*#__PURE__*/React__default["default"].createElement(feCore.ControlledField, {
        module: "admin",
        id: "userFilter.userTypes",
        field: /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
          pubRef: "admin.UserTypesPicker",
          value: this.filterValue("userTypes"),
          onChange: function onChange(v) {
            return _this2.onChangeUserTypes(v);
          }
        }))
      }), /*#__PURE__*/React__default["default"].createElement(feCore.ControlledField, {
        module: "admin",
        id: "userFilter.userRoles",
        field: /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
          pubRef: "admin.UserRolesPicker",
          value: this.filterValue("roles"),
          onChange: function onChange(v) {
            return _this2.onChangeUserRoles(v);
          }
        }))
      }), /*#__PURE__*/React__default["default"].createElement(feCore.ControlledField, {
        module: "admin",
        id: "userFilter.healthFacility",
        field: /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
          pubRef: "location.HealthFacilityPicker",
          withNull: true,
          value: this.filterValue("healthFacilityId") || "",
          district: selectedDistrict,
          onChange: function onChange(v) {
            onChangeFilters([{
              id: "healthFacility",
              value: v,
              filter: v ? "healthFacilityId: ".concat(feCore.decodeId(v.id)) : null
            }]);
          }
        }))
      })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
        container: true
      }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
        item: true,
        xs: 12
      }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
        pubRef: "location.DetailedLocationFilter",
        withNull: true,
        filters: filters,
        onChangeFilters: this.onChangeLocation,
        anchor: "parentLocation"
      }))), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
        container: true
      }, /*#__PURE__*/React__default["default"].createElement(feCore.ControlledField, {
        module: "admin",
        id: "userFilter.username",
        field: /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
          module: "user",
          label: "admin.user.username",
          name: "username",
          value: this.filterTextFieldValue("username"),
          onChange: function onChange(v) {
            return _this2.debouncedOnChangeFilter([{
              id: "username",
              value: v,
              filter: "username_Icontains: \"".concat(v, "\"")
            }]);
          }
        }))
      }), this.renderLastNameFirst ? /*#__PURE__*/React__default["default"].createElement(React__default["default"].Fragment, null, this.renderLastNameField(classes), this.renderGivenNameField(classes)) : /*#__PURE__*/React__default["default"].createElement(React__default["default"].Fragment, null, this.renderGivenNameField(classes), this.renderLastNameField(classes)), /*#__PURE__*/React__default["default"].createElement(feCore.ControlledField, {
        module: "admin",
        id: "userFilter.Email",
        field: /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
          module: "user",
          label: "admin.user.email",
          name: "email",
          value: this.filterTextFieldValue("email"),
          onChange: function onChange(v) {
            return _this2.debouncedOnChangeFilter([{
              id: "email",
              value: v,
              filter: "email: \"".concat(v, "\"")
            }]);
          }
        }))
      })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
        container: true
      }, /*#__PURE__*/React__default["default"].createElement(feCore.ControlledField, {
        module: "admin",
        id: "userFilter.Phone",
        field: /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
          module: "user",
          label: "admin.user.phone",
          name: "phone",
          value: this.filterTextFieldValue("phone"),
          onChange: function onChange(v) {
            return _this2.debouncedOnChangeFilter([{
              id: "phone",
              value: v,
              filter: "phone: \"".concat(v, "\"")
            }]);
          }
        }))
      }), /*#__PURE__*/React__default["default"].createElement(feCore.ControlledField, {
        module: "admin",
        id: "UserFilter.dob",
        field: /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          item: true,
          xs: 6
        }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          container: true
        }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          item: true,
          xs: 6,
          className: classes.item
        }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
          pubRef: "core.DatePicker",
          value: this.filterValue("dobFrom"),
          module: "user",
          label: "admin.user.dobFrom",
          onChange: function onChange(d) {
            return onChangeFilters([{
              id: "dobFrom",
              value: d,
              filter: "birthDateFrom: \"".concat(d, "\"")
            }]);
          }
        })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          item: true,
          xs: 6,
          className: classes.item
        }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
          pubRef: "core.DatePicker",
          value: this.filterValue("dobTo"),
          module: "user",
          label: "admin.user.dobTo",
          onChange: function onChange(d) {
            return onChangeFilters([{
              id: "dobTo",
              value: d,
              filter: "birthDateTo: \"".concat(d, "\"")
            }]);
          }
        }))))
      }), /*#__PURE__*/React__default["default"].createElement(feCore.ControlledField, {
        module: "policy",
        id: "PolicyFilter.showDeleted",
        field: /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          item: true,
          xs: 2,
          className: classes.item
        }, /*#__PURE__*/React__default["default"].createElement(core.FormControlLabel, {
          control: /*#__PURE__*/React__default["default"].createElement(core.Checkbox, {
            color: "primary",
            checked: !!this.filterValue("showDeleted"),
            onChange: function onChange(event) {
              return _this2.onChangeCheckbox("showDeleted", event.target.checked);
            }
          }),
          label: feCore.formatMessage(intl, "admin", "UserFilter.showDeleted")
        }))
      })));
    }
  }]);
}(React.Component);
var UserFilter$1 = feCore.withModulesManager(reactIntl.injectIntl(styles$a.withTheme(styles$a.withStyles(styles$9)(UserFilter))));

function _callSuper$2(t, o, e) { return o = _getPrototypeOf__default["default"](o), _possibleConstructorReturn__default["default"](t, _isNativeReflectConstruct$2() ? Reflect.construct(o, e || [], _getPrototypeOf__default["default"](t).constructor) : o.apply(t, e)); }
function _isNativeReflectConstruct$2() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct$2 = function _isNativeReflectConstruct() { return !!t; })(); }
var USER_SEARCHER_CONTRIBUTION_KEY = "user.UserSearcher";
var styles$8 = function styles(theme) {
  return {
    horizontalButtonContainer: theme.buttonContainer.horizontal
  };
};
var UserSearcher = /*#__PURE__*/function (_Component) {
  function UserSearcher(props) {
    var _this;
    _classCallCheck__default["default"](this, UserSearcher);
    _this = _callSuper$2(this, UserSearcher, [props]);
    _defineProperty__default["default"](_this, "state", {
      deleteUser: null,
      params: {},
      defaultParams: {}
    });
    _defineProperty__default["default"](_this, "getHeaders", function () {
      return ["admin.user.username", _this.renderLastNameFirst ? "admin.user.lastName" : "admin.user.otherNames", !_this.renderLastNameFirst ? "admin.user.lastName" : "admin.user.otherNames", "admin.user.email", "admin.user.phone", "admin.user.dob", ""];
    });
    _defineProperty__default["default"](_this, "getSorts", function () {
      return [["username", true], _this.renderLastNameFirst ? ["iUser_LastName", true] : ["iUser_OtherNames", true], !_this.renderLastNameFirst ? ["iUser_LastName", true] : ["iUser_OtherNames", true], ["iUser_Email", true], ["iUser_Phone", true], ["officer__dob", false]];
    });
    _defineProperty__default["default"](_this, "getAligns", function () {
      var aligns = _this.getHeaders().map(function () {
        return null;
      });
      aligns.splice(-1, 1, "right");
      return aligns;
    });
    _defineProperty__default["default"](_this, "fetch", function (params) {
      _this.setState({
        params: params
      });
      if (_this.props.fetchedUserLocation) {
        _this.props.fetchUsersSummaries(_this.props.modulesManager, params);
      }
    });
    _defineProperty__default["default"](_this, "setRegionIds", function (paramsArray) {
      var _this$props$userL0s;
      var regionIds = (_this$props$userL0s = _this.props.userL0s) === null || _this$props$userL0s === void 0 ? void 0 : _this$props$userL0s.map(function (region) {
        return feCore.decodeId(region.id);
      });
      paramsArray.push("regionIds: [".concat(regionIds, "]"));
    });
    _defineProperty__default["default"](_this, "componentDidUpdate", function (prevState) {
      if (prevState.userL0s !== _this.props.userL0s) {
        if (_this.props.userL0s && _this.props.fetchedUserLocation) {
          var prms = _toConsumableArray__default["default"](_this.state.params);
          _this.setRegionIds(prms);
          _this.props.fetchUsersSummaries(_this.props.modulesManager, prms);
        }
      }
    });
    _defineProperty__default["default"](_this, "filtersToQueryParams", function (state) {
      var prms = Object.keys(state.filters).filter(function (contrib) {
        return !!state.filters[contrib].filter;
      }).map(function (contrib) {
        return state.filters[contrib].filter;
      });
      if (!state.beforeCursor && !state.afterCursor) {
        prms.push("first: ".concat(state.pageSize));
      }
      if (state.afterCursor) {
        prms.push("after: \"".concat(state.afterCursor, "\""));
        prms.push("first: ".concat(state.pageSize));
      }
      if (state.beforeCursor) {
        prms.push("before: \"".concat(state.beforeCursor, "\""));
        prms.push("last: ".concat(state.pageSize));
      }
      if (state.orderBy) {
        prms.push("orderBy: [\"".concat(state.orderBy, "\"]"));
      }
      if (_this.props.fetchedUserLocation) {
        _this.setRegionIds(prms);
      }
      return prms;
    });
    _defineProperty__default["default"](_this, "deleteUser", function (isConfirmed) {
      if (!isConfirmed) {
        _this.setState({
          deleteUser: null
        });
      } else {
        var user = _this.state.deleteUser;
        _this.setState({
          deleteUser: null
        }, /*#__PURE__*/_asyncToGenerator__default["default"]( /*#__PURE__*/_regeneratorRuntime__default["default"].mark(function _callee() {
          return _regeneratorRuntime__default["default"].wrap(function _callee$(_context) {
            while (1) switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return _this.props.deleteUser(_this.props.modulesManager, user, feCore.formatMessage(_this.props.intl, "admin.user", "deleteDialog.title"));
              case 2:
                _this.fetch(_this.state.params);
              case 3:
              case "end":
                return _context.stop();
            }
          }, _callee);
        })));
      }
    });
    _defineProperty__default["default"](_this, "getUserItem", function (user, item) {
      return user.iUser && user.iUser[item] || user.officer && user.officer[item] || user.claimAdmin && user.claimAdmin[item];
    });
    _defineProperty__default["default"](_this, "itemFormatters", function () {
      var formatters = [function (u) {
        return u.username;
      }, function (u) {
        return _this.renderLastNameFirst ? _this.getUserItem(u, "lastName") : _this.getUserItem(u, "otherNames");
      }, function (u) {
        return !_this.renderLastNameFirst ? _this.getUserItem(u, "lastName") : _this.getUserItem(u, "otherNames");
      }, function (u) {
        return _this.getUserItem(u, "email") || _this.getUserItem(u, "emailId");
      }, function (u) {
        return _this.getUserItem(u, "phone");
      }, function (u) {
        return (u.claimAdmin || u.officer) && feCore.formatDateFromISO(_this.props.modulesManager, _this.props.intl, _this.getUserItem(u, "dob"));
      }, function (u) {
        return /*#__PURE__*/React__default["default"].createElement("div", {
          className: _this.props.classes.horizontalButtonContainer
        }, /*#__PURE__*/React__default["default"].createElement(core.Tooltip, {
          title: feCore.formatMessage(_this.props.intl, "admin.user", "openNewTab")
        }, /*#__PURE__*/React__default["default"].createElement(core.IconButton, {
          onClick: function onClick() {
            return _this.props.onDoubleClick(u, true);
          }
        }, /*#__PURE__*/React__default["default"].createElement(icons.Tab, null))), _this.props.rights.includes(RIGHT_USER_DELETE) && u.validityTo ? null : /*#__PURE__*/React__default["default"].createElement(core.Tooltip, {
          title: feCore.formatMessage(_this.props.intl, "admin.user", "deleteUser.tooltip")
        }, /*#__PURE__*/React__default["default"].createElement(core.IconButton, {
          onClick: function onClick() {
            return _this.setState({
              deleteUser: u
            });
          },
          disabled: u.validityTo
        }, /*#__PURE__*/React__default["default"].createElement(icons.Delete, null))));
      }];
      return formatters;
    });
    _this.renderLastNameFirst = props.modulesManager.getConf("fe-insuree", "renderLastNameFirst", DEFAULT.RENDER_LAST_NAME_FIRST);
    return _this;
  }
  _inherits__default["default"](UserSearcher, _Component);
  return _createClass__default["default"](UserSearcher, [{
    key: "render",
    value: function render() {
      var _usersPageInfo$totalC;
      var _this$props = this.props,
        intl = _this$props.intl,
        users = _this$props.users,
        usersPageInfo = _this$props.usersPageInfo,
        fetchingUsers = _this$props.fetchingUsers,
        fetchedUsers = _this$props.fetchedUsers,
        errorUsers = _this$props.errorUsers,
        cacheFiltersKey = _this$props.cacheFiltersKey,
        onDoubleClick = _this$props.onDoubleClick;
      return /*#__PURE__*/React__default["default"].createElement(React__default["default"].Fragment, null, this.state.deleteUser && /*#__PURE__*/React__default["default"].createElement(feCore.ConfirmDialog, {
        confirm: {
          title: feCore.formatMessage(intl, "admin.user", "deleteDialog.title"),
          message: feCore.formatMessage(intl, "admin.user", "deleteDialog.message")
        },
        onConfirm: this.deleteUser
      }), /*#__PURE__*/React__default["default"].createElement(feCore.Searcher, {
        module: "user",
        cacheFiltersKey: cacheFiltersKey,
        FilterPane: UserFilter$1,
        items: users,
        itemsPageInfo: usersPageInfo,
        fetchingItems: fetchingUsers,
        fetchedItems: fetchedUsers,
        errorItems: errorUsers,
        contributionKey: USER_SEARCHER_CONTRIBUTION_KEY,
        tableTitle: feCore.formatMessageWithValues(intl, "admin.user", "userSummaries", {
          count: (_usersPageInfo$totalC = usersPageInfo.totalCount) === null || _usersPageInfo$totalC === void 0 ? void 0 : _usersPageInfo$totalC.toString().replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,")
        }),
        fetch: this.fetch,
        rowIdentifier: function rowIdentifier(r) {
          return r.uuid;
        },
        filtersToQueryParams: this.filtersToQueryParams,
        defaultOrderBy: "-username",
        headers: this.getHeaders,
        aligns: this.getAligns,
        itemFormatters: this.itemFormatters,
        sorts: this.getSorts,
        rowDisabled: function rowDisabled(_, i) {
          return i.validityTo || i.clientMutationId;
        },
        rowLocked: function rowLocked(_, i) {
          return i.clientMutationId;
        },
        onDoubleClick: onDoubleClick
      }));
    }
  }]);
}(React.Component);
var mapStateToProps$3 = function mapStateToProps(state) {
  var _state$core$i_user$ri, _state$core, _state$loc$userL0s;
  return {
    rights: (_state$core$i_user$ri = (_state$core = state.core) === null || _state$core === void 0 || (_state$core = _state$core.i_user) === null || _state$core === void 0 ? void 0 : _state$core.rights) !== null && _state$core$i_user$ri !== void 0 ? _state$core$i_user$ri : [],
    users: state.admin.usersSummaries.items,
    usersPageInfo: state.admin.usersSummaries.pageInfo,
    fetchingUsers: state.admin.usersSummaries.isFetching,
    fetchedUsers: state.admin.usersSummaries.fetched,
    errorUsers: state.admin.usersSummaries.error,
    userL0s: (_state$loc$userL0s = state.loc.userL0s) !== null && _state$loc$userL0s !== void 0 ? _state$loc$userL0s : [],
    fetchedUserLocation: state.loc.fetchedUserLocation
  };
};
var mapDispatchToProps$2 = function mapDispatchToProps(dispatch) {
  return redux.bindActionCreators({
    fetchUsersSummaries: fetchUsersSummaries,
    deleteUser: deleteUser
  }, dispatch);
};
var UserSearcher$1 = feCore.withModulesManager(reactRedux.connect(mapStateToProps$3, mapDispatchToProps$2)(reactIntl.injectIntl(styles$a.withTheme(styles$a.withStyles(styles$8)(UserSearcher)))));

function _callSuper$1(t, o, e) { return o = _getPrototypeOf__default["default"](o), _possibleConstructorReturn__default["default"](t, _isNativeReflectConstruct$1() ? Reflect.construct(o, e || [], _getPrototypeOf__default["default"](t).constructor) : o.apply(t, e)); }
function _isNativeReflectConstruct$1() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct$1 = function _isNativeReflectConstruct() { return !!t; })(); }
var styles$7 = function styles(theme) {
  return {
    page: theme.page,
    fab: theme.fab
  };
};
var UsersPage = /*#__PURE__*/function (_Component) {
  function UsersPage() {
    var _this;
    _classCallCheck__default["default"](this, UsersPage);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _callSuper$1(this, UsersPage, [].concat(args));
    _defineProperty__default["default"](_this, "onDoubleClick", function (u) {
      var newTab = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      feCore.historyPush(_this.props.modulesManager, _this.props.history, "admin.userOverview", [u.id], newTab);
    });
    _defineProperty__default["default"](_this, "onAdd", function () {
      feCore.historyPush(_this.props.modulesManager, _this.props.history, "admin.userNew");
    });
    _defineProperty__default["default"](_this, "componentDidMount", function () {
      var module = _this.props.module;
      if (module !== MODULE_NAME) _this.props.clearCurrentPaginationPage();
    });
    return _this;
  }
  _inherits__default["default"](UsersPage, _Component);
  return _createClass__default["default"](UsersPage, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        classes = _this$props.classes,
        rights = _this$props.rights,
        intl = _this$props.intl;
      return /*#__PURE__*/React__default["default"].createElement("div", {
        className: classes.page
      }, /*#__PURE__*/React__default["default"].createElement(UserSearcher$1, {
        cacheFiltersKey: "usersPageFiltersCache",
        onDoubleClick: this.onDoubleClick
      }), rights.includes(RIGHT_USER_ADD) && feCore.withTooltip( /*#__PURE__*/React__default["default"].createElement("div", {
        className: classes.fab
      }, /*#__PURE__*/React__default["default"].createElement(core.Fab, {
        color: "primary",
        onClick: this.onAdd
      }, /*#__PURE__*/React__default["default"].createElement(AddIcon__default["default"], null))), feCore.formatMessage(intl, "admin.user", "addNewUser.tooltip")));
    }
  }]);
}(React.Component);
var mapStateToProps$2 = function mapStateToProps(state) {
  var _state$core$user$i_us, _state$core, _state$core2;
  return {
    rights: (_state$core$user$i_us = (_state$core = state.core) === null || _state$core === void 0 || (_state$core = _state$core.user) === null || _state$core === void 0 || (_state$core = _state$core.i_user) === null || _state$core === void 0 ? void 0 : _state$core.rights) !== null && _state$core$user$i_us !== void 0 ? _state$core$user$i_us : [],
    module: (_state$core2 = state.core) === null || _state$core2 === void 0 || (_state$core2 = _state$core2.savedPagination) === null || _state$core2 === void 0 ? void 0 : _state$core2.module
  };
};
var mapDispatchToProps$1 = function mapDispatchToProps(dispatch) {
  return redux.bindActionCreators({
    clearCurrentPaginationPage: feCore.clearCurrentPaginationPage
  }, dispatch);
};
var UsersPage$1 = reactIntl.injectIntl(feCore.withModulesManager(feCore.withHistory(reactRedux.connect(mapStateToProps$2, mapDispatchToProps$1)(styles$a.withTheme(styles$a.withStyles(styles$7)(UsersPage))))));

var styles$6 = function styles(theme) {
  return {
    footer: {
      marginInline: 16,
      marginBlock: 12
    },
    headerTitle: theme.table.title,
    actionCell: {
      width: 60
    },
    header: theme.table.header
  };
};
var groupVillagesByMunicipality = function groupVillagesByMunicipality(villages) {
  var result = [];
  villages === null || villages === void 0 || villages.forEach(function (village) {
    if (!result.find(function (x) {
      var _x$parent, _village$parent;
      return ((_x$parent = x.parent) === null || _x$parent === void 0 ? void 0 : _x$parent.id) === ((_village$parent = village.parent) === null || _village$parent === void 0 ? void 0 : _village$parent.id);
    })) {
      result.push({
        parent: village.parent,
        entities: []
      });
    }
    result.find(function (x) {
      var _x$parent2, _village$parent2;
      return ((_x$parent2 = x.parent) === null || _x$parent2 === void 0 ? void 0 : _x$parent2.id) === ((_village$parent2 = village.parent) === null || _village$parent2 === void 0 ? void 0 : _village$parent2.id);
    }).entities.push(village);
  });
  result.sort(function (a, b) {
    var _a$parent, _b$parent;
    return a.parent ? ((_a$parent = a.parent) === null || _a$parent === void 0 ? void 0 : _a$parent.id) > ((_b$parent = b.parent) === null || _b$parent === void 0 ? void 0 : _b$parent.id) : -1;
  });
  return result;
};
var EnrolmentVillagesPicker = function EnrolmentVillagesPicker(props) {
  var modulesManager = props.modulesManager,
    readOnly = props.readOnly,
    villages = props.villages,
    onChange = props.onChange,
    classes = props.classes,
    districts = props.districts,
    isOfficerPanelEnabled = props.isOfficerPanelEnabled;
  var dispatch = reactRedux.useDispatch();
  var _useState = React.useState([]),
    _useState2 = _slicedToArray__default["default"](_useState, 2),
    items = _useState2[0],
    setItems = _useState2[1];
  var _useTranslations = feCore.useTranslations("admin.EnrolmentZonesPicker", modulesManager),
    formatMessage = _useTranslations.formatMessage;
  var pickedDistrictsUuids = districts && districts.map(function (district) {
    return district.uuid;
  });
  var savedEOVillages = reactRedux.useSelector(function (store) {
    var _store$admin$user;
    return (_store$admin$user = store.admin.user) === null || _store$admin$user === void 0 ? void 0 : _store$admin$user.officerVillages;
  });
  var isUserEdited = reactRedux.useSelector(function (store) {
    var _store$admin$user2;
    return (_store$admin$user2 = store.admin.user) === null || _store$admin$user2 === void 0 ? void 0 : _store$admin$user2.id;
  });
  var _useState3 = React.useState(false),
    _useState4 = _slicedToArray__default["default"](_useState3, 2),
    wasEmpty = _useState4[0],
    setWasEmpty = _useState4[1];
  var _useSelector = reactRedux.useSelector(function (store) {
      return store.admin;
    }),
    districtMunAndVil = _useSelector.districtMunAndVil,
    fetchedDistrictMunAndVil = _useSelector.fetchedDistrictMunAndVil,
    fetchingDistrictMunAndVil = _useSelector.fetchingDistrictMunAndVil,
    errorDistrictMunAndVil = _useSelector.errorDistrictMunAndVil;
  var handleChange = function handleChange(newItems) {
    var villageIds = newItems.reduce(function (acc, item) {
      return item.entities ? acc.concat(item.entities) : acc;
    }, []);
    onChange(villageIds);
  };
  var onRemoveRow = function onRemoveRow(row) {
    handleChange(items.filter(function (i) {
      var _i$parent, _row$parent;
      return ((_i$parent = i.parent) === null || _i$parent === void 0 ? void 0 : _i$parent.id) !== ((_row$parent = row.parent) === null || _row$parent === void 0 ? void 0 : _row$parent.id);
    }));
  };
  React.useEffect(function () {
    setItems(groupVillagesByMunicipality(villages));
  }, [villages]);
  var onInsertRow = function onInsertRow() {
    setItems([].concat(_toConsumableArray__default["default"](items), [{}]));
  };
  var onSelectParent = function onSelectParent(item, parent) {
    var rowItem = item;
    rowItem.parent = parent;
    setItems(_toConsumableArray__default["default"](items));
  };
  var onVillagesChange = function onVillagesChange(item, entities) {
    var rowItem = item;
    rowItem.entities = entities;
    handleChange(items);
  };
  var createRow = function createRow(parent) {
    var _edges$map;
    var edges = parent.children.edges;
    var entities = (_edges$map = edges === null || edges === void 0 ? void 0 : edges.map(function (edge) {
      return edge.node;
    })) !== null && _edges$map !== void 0 ? _edges$map : [];
    var savedEntities = entities.filter(function (entity) {
      return savedEOVillages === null || savedEOVillages === void 0 ? void 0 : savedEOVillages.some(function (village) {
        return entity.uuid === (village === null || village === void 0 ? void 0 : village.uuid);
      });
    });
    var createdRow = {};
    createdRow.parent = parent;
    if (!isUserEdited) {
      createdRow.entities = entities;
      return createdRow;
    }
    if (isUserEdited && savedEntities && wasEmpty) {
      createdRow.entities = entities;
      return createdRow;
    }
    if (entities.find(function (entity) {
      return savedEntities.some(function (savedEntity) {
        return savedEntity.uuid !== entity.uuid;
      });
    })) {
      createdRow.entities = savedEntities;
    } else {
      createdRow.entities = entities;
    }
    return createdRow;
  };
  var rescheduleItems = function rescheduleItems(rows) {
    setItems([].concat(_toConsumableArray__default["default"](items), _toConsumableArray__default["default"](rows)));
    handleChange([].concat(_toConsumableArray__default["default"](items), _toConsumableArray__default["default"](rows)));
  };
  var clearItems = function clearItems() {
    setItems([]);
    handleChange([]);
    dispatch(clearDistrictData());
  };
  var executeNewRows = function executeNewRows(newRows, uniqueRows) {
    if (!items.length) {
      rescheduleItems(newRows);
    } else {
      rescheduleItems(uniqueRows);
    }
  };
  var filterParents = function filterParents(options) {
    return options.filter(function (p) {
      return !items.some(function (i) {
        var _i$parent2;
        return ((_i$parent2 = i.parent) === null || _i$parent2 === void 0 ? void 0 : _i$parent2.id) === p.id;
      });
    });
  };
  var filterVillages = function filterVillages(options) {
    return options.filter(function (option) {
      return !(villages !== null && villages !== void 0 && villages.some(function (village) {
        return (village === null || village === void 0 ? void 0 : village.id) === option.id;
      }));
    });
  };
  React.useEffect(function () {
    if (districts !== null && districts !== void 0 && districts.length) {
      dispatch(fetchDataFromDistrict(pickedDistrictsUuids));
    } else setWasEmpty(true);
    return clearItems();
  }, [districts]);
  React.useEffect(function () {
    if (fetchedDistrictMunAndVil) {
      var createdRows = districtMunAndVil.map(function (mun) {
        return createRow(mun);
      });
      var uniqueRows = createdRows.filter(function (row) {
        return !items.some(function (i) {
          return i.parent.uuid === row.parent.uuid;
        });
      });
      executeNewRows(createdRows, uniqueRows);
    }
  }, [districtMunAndVil]);
  React.useEffect(function () {
    if (isOfficerPanelEnabled) {
      clearItems();
    }
  }, [isOfficerPanelEnabled]);
  return /*#__PURE__*/React__default["default"].createElement(core.TableContainer, {
    component: core.Paper
  }, /*#__PURE__*/React__default["default"].createElement(core.Table, {
    size: "small"
  }, /*#__PURE__*/React__default["default"].createElement(core.TableHead, {
    className: classes.header
  }, /*#__PURE__*/React__default["default"].createElement(core.TableRow, {
    className: classes.headerTitle
  }, /*#__PURE__*/React__default["default"].createElement(core.TableCell, null, formatMessage("table.municipality")), /*#__PURE__*/React__default["default"].createElement(core.TableCell, null, formatMessage("table.villages")), /*#__PURE__*/React__default["default"].createElement(core.TableCell, null))), /*#__PURE__*/React__default["default"].createElement(core.TableBody, null, /*#__PURE__*/React__default["default"].createElement(feCore.ProgressOrError, {
    progress: fetchingDistrictMunAndVil,
    error: errorDistrictMunAndVil
  }), items.map(function (item) {
    var _item$parent, _item$parent2;
    return /*#__PURE__*/React__default["default"].createElement(core.TableRow, {
      key: (_item$parent = item.parent) === null || _item$parent === void 0 ? void 0 : _item$parent.id
    }, /*#__PURE__*/React__default["default"].createElement(core.TableCell, null, item.parent ? "".concat(item.parent.code, " ").concat(item.parent.name) : /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
      pubRef: "location.LocationPicker",
      parentLocations: pickedDistrictsUuids,
      onChange: function onChange(parent) {
        return onSelectParent(item, parent);
      },
      required: true,
      filterOptions: filterParents,
      value: item.parent,
      locationLevel: 2
    })), /*#__PURE__*/React__default["default"].createElement(core.TableCell, null, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
      fullWidth: true,
      pubRef: "location.LocationPicker",
      parentLocation: item.parent,
      parentLocations: [(_item$parent2 = item.parent) === null || _item$parent2 === void 0 ? void 0 : _item$parent2.uuid],
      readOnly: readOnly,
      required: true,
      multiple: true,
      value: item.entities,
      onChange: function onChange(value) {
        return onVillagesChange(item, value);
      },
      filterOptions: filterVillages,
      locationLevel: 3
    })), /*#__PURE__*/React__default["default"].createElement(core.TableCell, {
      className: classes.actionCell
    }, /*#__PURE__*/React__default["default"].createElement(core.IconButton, {
      disabled: readOnly,
      onClick: function onClick() {
        return onRemoveRow(item);
      }
    }, /*#__PURE__*/React__default["default"].createElement(DeleteIcon__default["default"], null))));
  })), /*#__PURE__*/React__default["default"].createElement(core.TableFooter, null, /*#__PURE__*/React__default["default"].createElement(core.Button, {
    disabled: readOnly,
    variant: "contained",
    onClick: onInsertRow,
    startIcon: /*#__PURE__*/React__default["default"].createElement(AddIcon__default["default"], null),
    className: classes.footer
  }, formatMessage("table.newRow")))));
};
var enhance$3 = feCore.combine(feCore.withModulesManager, styles$a.withTheme, styles$a.withStyles(styles$6));
var EnrolmentVillagesPicker$1 = enhance$3(EnrolmentVillagesPicker);

function ownKeys$5(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$5(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$5(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$5(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var styles$5 = function styles(theme) {
  return {
    item: theme.paper.item,
    paper: theme.paper.paper,
    title: theme.paper.title
  };
};
var EnrolmentOfficerFormPanel = function EnrolmentOfficerFormPanel(props) {
  var _edited$userTypes, _edited$worksTo, _edited$address;
  var edited = props.edited,
    classes = props.classes,
    modulesManager = props.modulesManager,
    onEditedChanged = props.onEditedChanged,
    readOnly = props.readOnly;
  var _useTranslations = feCore.useTranslations("admin.EnrolmentOfficerFormPanel", modulesManager),
    formatMessage = _useTranslations.formatMessage;
  var _useState = React.useState(false),
    _useState2 = _slicedToArray__default["default"](_useState, 2),
    isEnabled = _useState2[0],
    setIsEnabled = _useState2[1];
  var hasOfficerUserType = (_edited$userTypes = edited.userTypes) === null || _edited$userTypes === void 0 ? void 0 : _edited$userTypes.includes(ENROLMENT_OFFICER_USER_TYPE);
  var hasOfficerRole = edited.roles ? edited.roles.filter(function (x) {
    return x.isSystem === OFFICER_ROLE_IS_SYSTEM;
  }).length !== 0 : false;
  var _useGraphqlQuery = feCore.useGraphqlQuery("\n      query UserRolesPicker ($system_id: Int) {\n        role(systemRoleId: $system_id) {\n          edges {\n            node {\n              id name isSystem\n            }\n          }\n        }\n      }\n    ", {
      system_id: OFFICER_ROLE_IS_SYSTEM
    }),
    isLoading = _useGraphqlQuery.isLoading,
    data = _useGraphqlQuery.data;
    _useGraphqlQuery.error;
  var isValid = !isLoading;
  React.useEffect(function () {
    toggleUserRoles(edited, data, isValid, isEnabled, hasOfficerRole, onEditedChanged, OFFICER_ROLE_IS_SYSTEM);
  }, [isEnabled]);
  React.useEffect(function () {
    toggleSwitchButton(edited, hasOfficerRole, hasOfficerUserType, setIsEnabled, onEditedChanged, ENROLMENT_OFFICER_USER_TYPE);
  }, [hasOfficerRole]);
  return /*#__PURE__*/React__default["default"].createElement(core.Paper, {
    className: classes.paper
  }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 12,
    className: classes.title
  }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    container: true,
    justifyContent: "space-between",
    alignItems: "center"
  }, /*#__PURE__*/React__default["default"].createElement(core.Typography, {
    variant: "h6"
  }, formatMessage("title")), (edited || !isEnabled) && /*#__PURE__*/React__default["default"].createElement(core.Switch, {
    color: "secondary",
    disabled: readOnly,
    checked: isEnabled,
    onChange: function onChange() {
      return setIsEnabled(function () {
        return !isEnabled;
      });
    }
  }))), isEnabled && /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 12
  }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    container: true
  }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
    pubRef: "core.DatePicker",
    value: edited === null || edited === void 0 ? void 0 : edited.birthDate,
    module: "admin",
    label: "user.dob",
    readOnly: readOnly,
    maxDate: new Date(),
    onChange: function onChange(birthDate) {
      return onEditedChanged(_objectSpread$5(_objectSpread$5({}, edited), {}, {
        birthDate: birthDate
      }));
    }
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
    pubRef: "admin.SubstitutionEnrolmentOfficerPicker",
    module: "admin",
    readOnly: readOnly,
    withLabel: true,
    withPlaceholder: true,
    value: edited.substitutionOfficer,
    villages: edited.officerVillages,
    onChange: function onChange(substitutionOfficer) {
      return onEditedChanged(_objectSpread$5(_objectSpread$5({}, edited), {}, {
        substitutionOfficer: substitutionOfficer
      }));
    }
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
    pubRef: "core.DatePicker",
    value: (_edited$worksTo = edited === null || edited === void 0 ? void 0 : edited.worksTo) !== null && _edited$worksTo !== void 0 ? _edited$worksTo : "",
    module: "admin",
    label: "user.worksTo",
    readOnly: readOnly,
    onChange: function onChange(worksTo) {
      return onEditedChanged(_objectSpread$5(_objectSpread$5({}, edited), {}, {
        worksTo: worksTo
      }));
    }
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 12,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
    module: "admin",
    label: "user.address",
    multiline: true,
    rows: 2,
    variant: "outlined",
    readOnly: readOnly,
    value: (_edited$address = edited === null || edited === void 0 ? void 0 : edited.address) !== null && _edited$address !== void 0 ? _edited$address : "",
    onChange: function onChange(address) {
      return onEditedChanged(_objectSpread$5(_objectSpread$5({}, edited), {}, {
        address: address
      }));
    }
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 12,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(EnrolmentVillagesPicker$1, {
    isOfficerPanelEnabled: isEnabled,
    readOnly: readOnly,
    districts: edited.districts,
    villages: edited.officerVillages,
    onChange: function onChange(officerVillages) {
      return onEditedChanged(_objectSpread$5(_objectSpread$5({}, edited), {}, {
        officerVillages: officerVillages
      }));
    }
  })))));
};
var enhance$2 = feCore.combine(feCore.withModulesManager, styles$a.withTheme, styles$a.withStyles(styles$5));
var EnrolmentOfficerFormPanel$1 = enhance$2(EnrolmentOfficerFormPanel);

function ownKeys$4(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$4(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$4(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$4(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var styles$4 = function styles(theme) {
  return {
    item: theme.paper.item,
    paper: theme.paper.paper,
    title: theme.paper.title
  };
};
var ClaimAdministratorFormPanel = function ClaimAdministratorFormPanel(props) {
  var _edited$userTypes;
  var edited = props.edited,
    classes = props.classes,
    modulesManager = props.modulesManager,
    onEditedChanged = props.onEditedChanged,
    readOnly = props.readOnly;
  var _useTranslations = feCore.useTranslations("admin.ClaimAdministratorFormPanel", modulesManager),
    formatMessage = _useTranslations.formatMessage;
  var hasClaimUserType = (_edited$userTypes = edited.userTypes) === null || _edited$userTypes === void 0 ? void 0 : _edited$userTypes.includes(CLAIM_ADMIN_USER_TYPE);
  var hasClaimRole = edited.roles ? edited.roles.filter(function (x) {
    return x.isSystem === CLAIM_ADMIN_IS_SYSTEM;
  }).length !== 0 : false;
  var _useState = React.useState(false),
    _useState2 = _slicedToArray__default["default"](_useState, 2),
    isEnabled = _useState2[0],
    setIsEnabled = _useState2[1];
  var _useGraphqlQuery = feCore.useGraphqlQuery("\n    query UserRolesPicker ($system_id: Int) {\n      role(systemRoleId: $system_id) {\n        edges {\n          node {\n            id name isSystem\n          }\n        }\n      }\n    }\n  ", {
      system_id: CLAIM_ADMIN_IS_SYSTEM
    }),
    isLoading = _useGraphqlQuery.isLoading,
    data = _useGraphqlQuery.data;
    _useGraphqlQuery.error;
  var isValid = !isLoading;
  React.useEffect(function () {
    toggleUserRoles(edited, data, isValid, isEnabled, hasClaimRole, onEditedChanged, CLAIM_ADMIN_IS_SYSTEM);
  }, [isEnabled]);
  React.useEffect(function () {
    toggleSwitchButton(edited, hasClaimRole, hasClaimUserType, setIsEnabled, onEditedChanged, CLAIM_ADMIN_USER_TYPE);
  }, [hasClaimRole]);
  return /*#__PURE__*/React__default["default"].createElement(core.Paper, {
    className: classes.paper
  }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 12,
    className: classes.title
  }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    container: true,
    justifyContent: "space-between",
    alignItems: "center"
  }, /*#__PURE__*/React__default["default"].createElement(core.Typography, {
    variant: "h6"
  }, formatMessage("title")), (edited || !isEnabled) && /*#__PURE__*/React__default["default"].createElement(core.Switch, {
    color: "secondary",
    disabled: readOnly,
    checked: isEnabled,
    onChange: function onChange() {
      return setIsEnabled(function () {
        return !isEnabled;
      });
    }
  }))), isEnabled && /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 12
  }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    container: true
  }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
    pubRef: "core.DatePicker",
    value: edited === null || edited === void 0 ? void 0 : edited.birthDate,
    module: "admin",
    label: "user.dob",
    readOnly: readOnly,
    maxDate: new Date(),
    onChange: function onChange(birthDate) {
      return onEditedChanged(_objectSpread$4(_objectSpread$4({}, edited), {}, {
        birthDate: birthDate
      }));
    }
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
    pubRef: "location.HealthFacilityPicker",
    value: edited === null || edited === void 0 ? void 0 : edited.healthFacility,
    district: edited === null || edited === void 0 ? void 0 : edited.districts,
    required: true,
    module: "admin",
    readOnly: readOnly,
    onChange: function onChange(healthFacility) {
      return onEditedChanged(_objectSpread$4(_objectSpread$4({}, edited), {}, {
        healthFacility: healthFacility
      }));
    }
  })))));
};
var enhance$1 = feCore.combine(feCore.withModulesManager, styles$a.withTheme, styles$a.withStyles(styles$4));
var ClaimAdministratorFormPanel$1 = enhance$1(ClaimAdministratorFormPanel);

var passwordGenerator = function passwordGenerator(options) {
  var _options$length, _options$isNumberRequ, _options$isLowerCaseR, _options$isUpperCaseR, _options$isSpecialSym;
  // This method should not be used to create safe/permament passwords for users
  // Passwords should be generated by browsers or password managers
  // Only justifiable use-case is creating temporary passwords valid until first login
  var uppercase = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  var lowercase = uppercase.toLowerCase();
  var numbers = "0123456789";
  var specialCharacters = "!@#$%^&*()_+-=[]{}|;:,.<>?";
  var length = (_options$length = options === null || options === void 0 ? void 0 : options.length) !== null && _options$length !== void 0 ? _options$length : 10;
  var isNumberRequired = (_options$isNumberRequ = options === null || options === void 0 ? void 0 : options.isNumberRequired) !== null && _options$isNumberRequ !== void 0 ? _options$isNumberRequ : true;
  var isLowerCaseRequired = (_options$isLowerCaseR = options === null || options === void 0 ? void 0 : options.isLowerCaseRequired) !== null && _options$isLowerCaseR !== void 0 ? _options$isLowerCaseR : true;
  var isUpperCaseRequired = (_options$isUpperCaseR = options === null || options === void 0 ? void 0 : options.isUpperCaseRequired) !== null && _options$isUpperCaseR !== void 0 ? _options$isUpperCaseR : true;
  var isSpecialSymbolRequired = (_options$isSpecialSym = options === null || options === void 0 ? void 0 : options.isSpecialSymbolRequired) !== null && _options$isSpecialSym !== void 0 ? _options$isSpecialSym : true;
  var password = "";
  var getCategoriesArray = function getCategoriesArray() {
    var availableCategories = [];
    if (isLowerCaseRequired) availableCategories.push(lowercase);
    if (isUpperCaseRequired) availableCategories.push(uppercase);
    if (isNumberRequired) availableCategories.push(numbers);
    if (isSpecialSymbolRequired) availableCategories.push(specialCharacters);
    return availableCategories;
  };
  var categoriesArray = getCategoriesArray();
  getSafeRandomNumberArray(length, categoriesArray.length).forEach(function (category) {
    password += getRandomOfType(categoriesArray[category]);
  });
  return password;
};
function getSafeRandomNumberArray(length, modulo) {
  // crypto.getRandomValues is coded in a way that is cryptographically secure
  // do not use Math.Random to generate password
  var seedArray = self.crypto.getRandomValues(new Uint32Array(length));
  return Array.from(seedArray, function (value) {
    return value % modulo;
  });
}
function getRandomOfType(charset) {
  return charset.charAt(getSafeRandomNumberArray(1, charset.length));
}

function ownKeys$3(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$3(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$3(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$3(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var styles$3 = function styles(theme) {
  return {
    tableTitle: theme.table.title,
    item: theme.paper.item,
    fullHeight: {
      height: "100%"
    },
    sectionHeader: _objectSpread$3(_objectSpread$3({}, theme.paper.item), {}, {
      paddingBottom: 0
    }),
    sectionTitle: theme.typography.title
  };
};
var UserMasterPanel = function UserMasterPanel(props) {
  var _edited$username, _edited$userTypes, _edited$email, _edited$userTypes2, _edited$userTypes3, _edited$phoneNumber, _edited$roles, _edited$districts, _edited$language;
  var classes = props.classes,
    edited = props.edited,
    readOnly = props.readOnly,
    onEditedChanged = props.onEditedChanged,
    modulesManager = props.modulesManager,
    obligatoryUserFields = props.obligatoryUserFields,
    obligatoryEOFields = props.obligatoryEOFields,
    isUsernameValid = props.isUsernameValid,
    isUsernameValidating = props.isUsernameValidating,
    usernameValidationError = props.usernameValidationError,
    isUserEmailValid = props.isUserEmailValid,
    isUserEmailValidating = props.isUserEmailValidating,
    isUserEmailFormatInvalid = props.isUserEmailFormatInvalid,
    emailValidationError = props.emailValidationError,
    savedUsername = props.savedUsername,
    savedUserEmail = props.savedUserEmail,
    usernameLength = props.usernameLength;
  var _useTranslations = feCore.useTranslations("admin", modulesManager),
    formatMessage = _useTranslations.formatMessage;
  var dispatch = reactRedux.useDispatch();
  var renderLastNameFirst = modulesManager.getConf("fe-insuree", "renderLastNameFirst", DEFAULT.RENDER_LAST_NAME_FIRST);
  var shouldValidateUsername = function shouldValidateUsername(inputValue) {
    var shouldBeValidated = inputValue !== savedUsername;
    return shouldBeValidated;
  };
  var shouldValidateEmail = function shouldValidateEmail(inputValue) {
    var shouldBeValidated = inputValue !== savedUserEmail;
    return shouldBeValidated;
  };
  var checkEmailFormatValidity = function checkEmailFormatValidity(emailInput) {
    if (!emailInput) return false;
    var isEmailInvalid = !EMAIL_REGEX_PATTERN.test(emailInput);
    return isEmailInvalid;
  };
  var handleEmailChange = function handleEmailChange(email) {
    var isFormatValid = checkEmailFormatValidity(email);
    dispatch(saveEmailFormatValidity(isFormatValid));
    onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
      email: email
    }));
  };
  React.useEffect(function () {
    handleEmailChange(edited === null || edited === void 0 ? void 0 : edited.email);
  }, []);
  var _useState = React.useState(false),
    _useState2 = _slicedToArray__default["default"](_useState, 2),
    showPassword = _useState2[0],
    setShowPassword = _useState2[1];
  var handleClickShowPassword = function handleClickShowPassword() {
    return setShowPassword(function (show) {
      return !show;
    });
  };
  var handleMouseDownPassword = function handleMouseDownPassword(event) {
    event.preventDefault();
  };
  var generatePassword = function generatePassword() {
    var passwordGeneratorOptions = modulesManager.getConf("fe-admin", "passwordGeneratorOptions", {
      length: 10,
      isNumberRequired: true,
      isLowerCaseRequired: true,
      isUpperCaseRequired: true,
      isSpecialSymbolRequired: true
    });
    var generatedPassword = passwordGenerator(passwordGeneratorOptions);
    onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
      password: generatedPassword,
      confirmPassword: generatedPassword
    }));
  };
  var renderLastNameField = function renderLastNameField(edited, classes, readOnly) {
    var _edited$lastName;
    return /*#__PURE__*/React__default["default"].createElement(core.Grid, {
      item: true,
      xs: 4,
      className: classes.item
    }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
      module: "admin",
      label: "user.lastName",
      required: true,
      readOnly: readOnly,
      value: (_edited$lastName = edited === null || edited === void 0 ? void 0 : edited.lastName) !== null && _edited$lastName !== void 0 ? _edited$lastName : "",
      onChange: function onChange(lastName) {
        return onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
          lastName: lastName
        }));
      }
    }));
  };
  var renderGivenNameField = function renderGivenNameField(edited, classes, readOnly) {
    var _edited$otherNames;
    return /*#__PURE__*/React__default["default"].createElement(core.Grid, {
      item: true,
      xs: 4,
      className: classes.item
    }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
      module: "admin",
      label: "user.givenNames",
      required: true,
      readOnly: readOnly,
      value: (_edited$otherNames = edited === null || edited === void 0 ? void 0 : edited.otherNames) !== null && _edited$otherNames !== void 0 ? _edited$otherNames : "",
      onChange: function onChange(otherNames) {
        return onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
          otherNames: otherNames
        }));
      }
    }));
  };
  return /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    container: true,
    direction: "row"
  }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.ValidatedTextInput, {
    itemQueryIdentifier: "username",
    shouldValidate: shouldValidateUsername,
    isValid: isUsernameValid,
    isValidating: isUsernameValidating,
    validationError: usernameValidationError,
    action: usernameValidationCheck,
    clearAction: usernameValidationClear,
    setValidAction: setUsernameValid,
    module: "admin",
    label: "user.username",
    codeTakenLabel: "user.usernameAlreadyTaken",
    required: true,
    value: (_edited$username = edited === null || edited === void 0 ? void 0 : edited.username) !== null && _edited$username !== void 0 ? _edited$username : "",
    readOnly: readOnly,
    onChange: function onChange(username) {
      return onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
        username: username
      }));
    },
    inputProps: {
      "maxLength": usernameLength
    }
  })), renderLastNameFirst ? /*#__PURE__*/React__default["default"].createElement(React__default["default"].Fragment, null, renderLastNameField(edited, classes, readOnly), renderGivenNameField(edited, classes, readOnly)) : /*#__PURE__*/React__default["default"].createElement(React__default["default"].Fragment, null, renderGivenNameField(edited, classes, readOnly), renderLastNameField(edited, classes, readOnly)), !((obligatoryUserFields === null || obligatoryUserFields === void 0 ? void 0 : obligatoryUserFields.email) == "H" || (_edited$userTypes = edited.userTypes) !== null && _edited$userTypes !== void 0 && _edited$userTypes.includes(ENROLMENT_OFFICER_USER_TYPE) && (obligatoryEOFields === null || obligatoryEOFields === void 0 ? void 0 : obligatoryEOFields.email) == "H") && /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.ValidatedTextInput, {
    itemQueryIdentifier: "userEmail",
    shouldValidate: shouldValidateEmail,
    isValid: isUserEmailValid,
    isValidating: isUserEmailValidating,
    validationError: emailValidationError,
    invalidValueFormat: isUserEmailFormatInvalid,
    action: userEmailValidationCheck,
    clearAction: userEmailValidationClear,
    setValidAction: setUserEmailValid,
    readOnly: readOnly,
    module: "admin",
    label: "user.email",
    type: "email",
    codeTakenLabel: "user.emailAlreadyTaken",
    required: true,
    value: (_edited$email = edited === null || edited === void 0 ? void 0 : edited.email) !== null && _edited$email !== void 0 ? _edited$email : "",
    onChange: function onChange(email) {
      return handleEmailChange(email);
    }
  })), !((obligatoryUserFields === null || obligatoryUserFields === void 0 ? void 0 : obligatoryUserFields.phone) == "H" || (_edited$userTypes2 = edited.userTypes) !== null && _edited$userTypes2 !== void 0 && _edited$userTypes2.includes(ENROLMENT_OFFICER_USER_TYPE) && (obligatoryEOFields === null || obligatoryEOFields === void 0 ? void 0 : obligatoryEOFields.phone) == "H") && /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
    module: "admin",
    type: "phone",
    label: "user.phone",
    required: (obligatoryUserFields === null || obligatoryUserFields === void 0 ? void 0 : obligatoryUserFields.phone) == "M" || ((_edited$userTypes3 = edited.userTypes) === null || _edited$userTypes3 === void 0 ? void 0 : _edited$userTypes3.includes(ENROLMENT_OFFICER_USER_TYPE)) && (obligatoryEOFields === null || obligatoryEOFields === void 0 ? void 0 : obligatoryEOFields.phone) == "M",
    readOnly: readOnly,
    value: (_edited$phoneNumber = edited === null || edited === void 0 ? void 0 : edited.phoneNumber) !== null && _edited$phoneNumber !== void 0 ? _edited$phoneNumber : "",
    onChange: function onChange(phoneNumber) {
      return onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
        phoneNumber: phoneNumber
      }));
    }
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
    pubRef: "location.HealthFacilityPicker",
    value: edited === null || edited === void 0 ? void 0 : edited.healthFacility,
    district: edited.districts,
    module: "admin",
    readOnly: readOnly,
    required: edited.userTypes.includes(CLAIM_ADMIN_USER_TYPE),
    onChange: function onChange(healthFacility) {
      return onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
        healthFacility: healthFacility
      }));
    }
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 6,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
    pubRef: "admin.UserRolesPicker",
    required: true,
    value: (_edited$roles = edited === null || edited === void 0 ? void 0 : edited.roles) !== null && _edited$roles !== void 0 ? _edited$roles : [],
    module: "admin",
    readOnly: readOnly,
    onChange: function onChange(roles) {
      return onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
        roles: roles
      }));
    }
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 2,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
    pubRef: "location.LocationPicker",
    locationLevel: 0,
    value: edited.region,
    onChange: function onChange(region) {
      return onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
        region: region
      }));
    },
    readOnly: readOnly,
    multiple: true,
    withLabel: true,
    label: formatMessage("user.regions"),
    restrictedOptions: true
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
    pubRef: "location.LocationPicker",
    locationLevel: 1,
    value: (_edited$districts = edited === null || edited === void 0 ? void 0 : edited.districts) !== null && _edited$districts !== void 0 ? _edited$districts : [],
    onChange: function onChange(districts) {
      return onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
        districts: districts
      }));
    },
    readOnly: readOnly,
    required: true,
    multiple: true,
    withLabel: true,
    label: formatMessage("user.districts"),
    restrictedOptions: true
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 12,
    className: classes.sectionHeader
  }, /*#__PURE__*/React__default["default"].createElement(core.Typography, {
    className: classes.sectionTitle
  }, formatMessage("UserMasterPanel.loginDetailsTitle")), /*#__PURE__*/React__default["default"].createElement(core.Divider, {
    variant: "fullWidth"
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
    pubRef: "core.LanguagePicker",
    module: "admin",
    label: "user.language",
    readOnly: readOnly,
    required: true,
    withNull: false,
    nullLabel: formatMessage("UserMasterPanel.language.null"),
    value: (_edited$language = edited.language) !== null && _edited$language !== void 0 ? _edited$language : "",
    onChange: function onChange(language) {
      return onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
        language: language
      }));
    }
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
    module: "admin",
    type: showPassword ? "text" : "password",
    label: "user.newPassword",
    readOnly: readOnly,
    value: edited.password,
    onChange: function onChange(password) {
      return onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
        password: password
      }));
    },
    endAdornment: /*#__PURE__*/React__default["default"].createElement(core.InputAdornment, {
      position: "end"
    }, /*#__PURE__*/React__default["default"].createElement(core.IconButton, {
      "aria-label": "toggle password visibility",
      onClick: handleClickShowPassword,
      onMouseDown: handleMouseDownPassword,
      edge: "end"
    }, showPassword ? /*#__PURE__*/React__default["default"].createElement(VisibilityOffIcon__default["default"], null) : /*#__PURE__*/React__default["default"].createElement(VisibilityIcon__default["default"], null)))
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
    module: "admin",
    type: showPassword ? "text" : "password",
    label: "user.confirmNewPassword",
    required: edited.password,
    readOnly: readOnly,
    value: edited.confirmPassword,
    onChange: function onChange(confirmPassword) {
      return onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
        confirmPassword: confirmPassword
      }));
    },
    endAdornment: /*#__PURE__*/React__default["default"].createElement(core.InputAdornment, {
      position: "end"
    }, /*#__PURE__*/React__default["default"].createElement(core.IconButton, {
      "aria-label": "toggle password visibility",
      onClick: handleClickShowPassword,
      onMouseDown: handleMouseDownPassword,
      edge: "end"
    }, showPassword ? /*#__PURE__*/React__default["default"].createElement(VisibilityOffIcon__default["default"], null) : /*#__PURE__*/React__default["default"].createElement(VisibilityIcon__default["default"], null)))
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(core.Button, {
    disabled: readOnly,
    variant: "contained",
    onClick: generatePassword
  }, formatMessage("user.generatePassword"))));
};
var mapStateToProps$1 = function mapStateToProps(state) {
  var _state$admin$validati, _state$admin$validati2, _state$admin$validati3, _state$admin, _state$admin$validati4, _state$admin$validati5, _state$admin$validati6, _state$admin2, _state$admin$validati7;
  return {
    isUsernameValid: (_state$admin$validati = state.admin.validationFields) === null || _state$admin$validati === void 0 || (_state$admin$validati = _state$admin$validati.username) === null || _state$admin$validati === void 0 ? void 0 : _state$admin$validati.isValid,
    isUsernameValidating: (_state$admin$validati2 = state.admin.validationFields) === null || _state$admin$validati2 === void 0 || (_state$admin$validati2 = _state$admin$validati2.username) === null || _state$admin$validati2 === void 0 ? void 0 : _state$admin$validati2.isValidating,
    usernameValidationError: (_state$admin$validati3 = state.admin.validationFields) === null || _state$admin$validati3 === void 0 || (_state$admin$validati3 = _state$admin$validati3.username) === null || _state$admin$validati3 === void 0 ? void 0 : _state$admin$validati3.validationError,
    savedUsername: (_state$admin = state.admin) === null || _state$admin === void 0 || (_state$admin = _state$admin.user) === null || _state$admin === void 0 ? void 0 : _state$admin.username,
    isUserEmailValid: (_state$admin$validati4 = state.admin.validationFields) === null || _state$admin$validati4 === void 0 || (_state$admin$validati4 = _state$admin$validati4.userEmail) === null || _state$admin$validati4 === void 0 ? void 0 : _state$admin$validati4.isValid,
    isUserEmailValidating: (_state$admin$validati5 = state.admin.validationFields) === null || _state$admin$validati5 === void 0 || (_state$admin$validati5 = _state$admin$validati5.userEmail) === null || _state$admin$validati5 === void 0 ? void 0 : _state$admin$validati5.isValidating,
    emailValidationError: (_state$admin$validati6 = state.admin.validationFields) === null || _state$admin$validati6 === void 0 || (_state$admin$validati6 = _state$admin$validati6.userEmail) === null || _state$admin$validati6 === void 0 ? void 0 : _state$admin$validati6.validationError,
    savedUserEmail: (_state$admin2 = state.admin) === null || _state$admin2 === void 0 || (_state$admin2 = _state$admin2.user) === null || _state$admin2 === void 0 ? void 0 : _state$admin2.email,
    isUserEmailFormatInvalid: (_state$admin$validati7 = state.admin.validationFields) === null || _state$admin$validati7 === void 0 || (_state$admin$validati7 = _state$admin$validati7.userEmailFormat) === null || _state$admin$validati7 === void 0 ? void 0 : _state$admin$validati7.isInvalid
  };
};
var UserMasterPanel$1 = feCore.withModulesManager(reactRedux.connect(mapStateToProps$1)(styles$a.withTheme(styles$a.withStyles(styles$3)(UserMasterPanel))));

function ownKeys$2(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$2(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$2(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$2(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _callSuper(t, o, e) { return o = _getPrototypeOf__default["default"](o), _possibleConstructorReturn__default["default"](t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf__default["default"](t).constructor) : o.apply(t, e)); }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
var styles$2 = function styles(theme) {
  return {
    lockedPage: theme.page.locked
  };
};
var USER_OVERVIEW_MUTATIONS_KEY = "user.UserOverview.mutations";
var setupState = function setupState(props) {
  return {
    isLocked: false,
    user: !(props !== null && props !== void 0 && props.userId) ? {
      userTypes: [INTERACTIVE_USER_TYPE]
    } : props.user,
    isSaved: false,
    reset: 0
  };
};
var UserForm = /*#__PURE__*/function (_Component) {
  function UserForm(props) {
    var _this;
    _classCallCheck__default["default"](this, UserForm);
    _this = _callSuper(this, UserForm, [props]);
    _defineProperty__default["default"](_this, "reload", /*#__PURE__*/_asyncToGenerator__default["default"]( /*#__PURE__*/_regeneratorRuntime__default["default"].mark(function _callee() {
      var isSaved, _this$props, modulesManager, history, mutation, fetchUserMutation, userId, fetchUser, clientMutationId, response, createdUserId;
      return _regeneratorRuntime__default["default"].wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            isSaved = _this.state.isSaved; // eslint-disable-next-line no-shadow
            _this$props = _this.props, modulesManager = _this$props.modulesManager, history = _this$props.history, mutation = _this$props.mutation, fetchUserMutation = _this$props.fetchUserMutation, userId = _this$props.userId, fetchUser = _this$props.fetchUser;
            if (!userId) {
              _context.next = 13;
              break;
            }
            _context.prev = 3;
            _context.next = 6;
            return fetchUser(modulesManager, userId);
          case 6:
            _context.next = 11;
            break;
          case 8:
            _context.prev = 8;
            _context.t0 = _context["catch"](3);
            // eslint-disable-next-line no-console
            console.error("[RELOAD_USER]: Fetching user details failed. ".concat(_context.t0));
          case 11:
            _this.setState(function (state) {
              return _objectSpread$2(_objectSpread$2({}, state), {}, {
                reset: state.reset + 1
              });
            });
            return _context.abrupt("return");
          case 13:
            if (!isSaved) {
              _context.next = 30;
              break;
            }
            _context.prev = 14;
            clientMutationId = mutation.clientMutationId;
            _context.next = 18;
            return fetchUserMutation(modulesManager, clientMutationId);
          case 18:
            response = _context.sent;
            createdUserId = feCore.parseData(response.payload.data.mutationLogs)[0].users[0].coreUser.id;
            _context.next = 22;
            return fetchUser(modulesManager, createdUserId);
          case 22:
            feCore.historyPush(modulesManager, history, "admin.userOverview", [createdUserId]);
            _context.next = 28;
            break;
          case 25:
            _context.prev = 25;
            _context.t1 = _context["catch"](14);
            // eslint-disable-next-line no-console
            console.error("[RELOAD_USER]: Fetching user details failed. ".concat(_context.t1));
          case 28:
            _this.setState(function (state) {
              return _objectSpread$2(_objectSpread$2({}, state), {}, {
                reset: state.reset + 1
              });
            });
            return _context.abrupt("return");
          case 30:
            _this.setState(setupState(_this.props));
          case 31:
          case "end":
            return _context.stop();
        }
      }, _callee, null, [[3, 8], [14, 25]]);
    })));
    _defineProperty__default["default"](_this, "canSave", function () {
      var _user$roles, _user$districts, _user$userTypes, _user$userTypes2, _this$props$obligator, _user$userTypes3, _this$props$obligator2;
      var user = _this.state.user;
      if (!user) return false;
      if (!(user.lastName && user.otherNames && user.username && user.email && _this.props.isUserNameValid === true && _this.props.isUserEmailValid === true && !_this.props.isUserEmailFormatInvalid && (_user$roles = user.roles) !== null && _user$roles !== void 0 && _user$roles.length && ((_user$districts = user.districts) === null || _user$districts === void 0 ? void 0 : _user$districts.length) > 0 && user.language)) return false;
      if (user.password && user.password !== user.confirmPassword) return false;
      if ((_user$userTypes = user.userTypes) !== null && _user$userTypes !== void 0 && _user$userTypes.includes(CLAIM_ADMIN_USER_TYPE) && !user.healthFacility) return false;
      if ((_user$userTypes2 = user.userTypes) !== null && _user$userTypes2 !== void 0 && _user$userTypes2.includes(ENROLMENT_OFFICER_USER_TYPE) && !user.officerVillages) return false;
      if ((((_this$props$obligator = _this.props.obligatory_user_fields) === null || _this$props$obligator === void 0 ? void 0 : _this$props$obligator.phone) === "M" || (_user$userTypes3 = user.userTypes) !== null && _user$userTypes3 !== void 0 && _user$userTypes3.includes(ENROLMENT_OFFICER_USER_TYPE) && ((_this$props$obligator2 = _this.props.obligatory_eo_fields) === null || _this$props$obligator2 === void 0 ? void 0 : _this$props$obligator2.phone) === "M") && !user.phoneNumber) return false;
      return true;
    });
    _defineProperty__default["default"](_this, "save", function (user) {
      _this.setState({
        isLocked: !(user !== null && user !== void 0 && user.id),
        isSaved: true
      }, _this.props.save(user));
    });
    _defineProperty__default["default"](_this, "onEditedChanged", function (user) {
      if (user.region) {
        user.region.forEach(function (region) {
          _this.props.fetchRegionDistricts(region);
        });
      }
      _this.setState({
        user: user
      });
    });
    _defineProperty__default["default"](_this, "onActionToConfirm", function (title, message, confirmedAction) {
      _this.setState({
        confirmedAction: confirmedAction
      }, _this.props.coreConfirm(title, message));
    });
    _this.state = setupState(props);
    return _this;
  }
  _inherits__default["default"](UserForm, _Component);
  return _createClass__default["default"](UserForm, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.userId) {
        this.props.fetchUser(this.props.modulesManager, this.props.userId);
      }
      if (!this.state.obligatory_user_fields) {
        this.props.fetchObligatoryUserFields();
      }
      if (!this.state.obligatory_eo_fields) {
        this.props.fetchObligatoryEnrolmentOfficerFields();
      }
      if (!this.state.usernameLength) {
        this.props.fetchUsernameLength();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.props.clearUser();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps.region_districts !== this.props.region_districts) {
        if (this.props.region_districts) {
          var combined = [].concat(_toConsumableArray__default["default"](this.state.user.districts ? this.state.user.districts : []), _toConsumableArray__default["default"](this.props.region_districts));
          var noDuplicates = _toConsumableArray__default["default"](new Map(combined.map(function (x) {
            return [x.uuid, x];
          })).values());
          this.setState(function (prevState) {
            return {
              user: _objectSpread$2(_objectSpread$2({}, prevState.user), {}, {
                districts: noDuplicates,
                region: []
              })
            };
          });
        }
      }
      if (!prevProps.fetchedUser && this.props.fetchedUser) {
        this.setState(setupState(this.props));
      } else if (prevProps.userId && !this.props.userId) {
        this.setState(setupState(this.props));
      } else if (prevProps.submittingMutation && !this.props.submittingMutation) {
        this.props.journalize(this.props.mutation);
        this.setState(function (state, props) {
          return {
            user: _objectSpread$2(_objectSpread$2({}, state.user), {}, {
              clientMutationId: props.mutation.clientMutationId
            })
          };
        });
      } else if (prevProps.confirmed !== this.props.confirmed && !!this.props.confirmed && !!this.state.confirmedAction) {
        this.state.confirmedAction();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
        modulesManager = _this$props2.modulesManager,
        classes = _this$props2.classes,
        state = _this$props2.state,
        rights = _this$props2.rights,
        userId = _this$props2.userId,
        fetchingUser = _this$props2.fetchingUser,
        errorUser = _this$props2.errorUser,
        _this$props2$readOnly = _this$props2.readOnly,
        readOnly = _this$props2$readOnly === void 0 ? false : _this$props2$readOnly,
        add = _this$props2.add,
        save = _this$props2.save,
        back = _this$props2.back,
        obligatoryUserFields = _this$props2.obligatoryUserFields,
        obligatoryEoFields = _this$props2.obligatoryEoFields,
        usernameLength = _this$props2.usernameLength;
      var _this$state = this.state,
        user = _this$state.user,
        isSaved = _this$state.isSaved,
        reset = _this$state.reset;
      if (!rights.includes(RIGHT_USERS)) return null;
      var isInMutation = (user === null || user === void 0 ? void 0 : user.clientMutationId) || modulesManager.getContribs(USER_OVERVIEW_MUTATIONS_KEY).some(function (mutation) {
        return mutation(state);
      });
      var actions = [{
        doIt: this.reload,
        icon: /*#__PURE__*/React__default["default"].createElement(ReplayIcon__default["default"], null),
        onlyIfDirty: !readOnly && !isInMutation && !isSaved
      }];
      return /*#__PURE__*/React__default["default"].createElement("div", {
        className: isInMutation || !!(user !== null && user !== void 0 && user.validityTo) ? classes.lockedPage : null
      }, /*#__PURE__*/React__default["default"].createElement(feCore.Helmet, {
        title: feCore.formatMessageWithValues(this.props.intl, "admin.user", "UserOverview.title", {
          label: ""
        })
      }), /*#__PURE__*/React__default["default"].createElement(feCore.ProgressOrError, {
        progress: fetchingUser,
        error: errorUser
      }), (!userId || (user === null || user === void 0 ? void 0 : user.id) === userId) && /*#__PURE__*/React__default["default"].createElement(feCore.Form, {
        module: "user",
        title: userId ? "admin.user.UserOverview.title" : "admin.user.UserOverview.newTitle",
        edited_id: userId,
        edited: user,
        reset: reset,
        back: back,
        add: add,
        openDirty: save,
        readOnly: readOnly || isInMutation || (user === null || user === void 0 ? void 0 : user.validityTo),
        actions: actions,
        HeadPanel: UserMasterPanel$1,
        Panels: [EnrolmentOfficerFormPanel$1, ClaimAdministratorFormPanel$1],
        user: user,
        onEditedChanged: this.onEditedChanged,
        canSave: !user.validityTo && this.canSave,
        save: save && !user.validityTo ? this.save : null,
        onActionToConfirm: this.onActionToConfirm,
        obligatory_user_fields: obligatoryUserFields,
        obligatory_eo_fields: obligatoryEoFields,
        usernameLength: usernameLength
      }));
    }
  }]);
}(React.Component);
var mapStateToProps = function mapStateToProps(state) {
  var _state$core$user$i_us, _state$core, _state$admin$validati, _state$admin$validati2, _state$admin, _state$admin$validati3;
  return {
    rights: (_state$core$user$i_us = (_state$core = state.core) === null || _state$core === void 0 || (_state$core = _state$core.user) === null || _state$core === void 0 || (_state$core = _state$core.i_user) === null || _state$core === void 0 ? void 0 : _state$core.rights) !== null && _state$core$user$i_us !== void 0 ? _state$core$user$i_us : [],
    fetchingUser: state.admin.fetchingUser,
    errorUser: state.admin.errorUser,
    fetchedUser: state.admin.fetchedUser,
    submittingMutation: state.admin.submittingMutation,
    mutation: state.admin.mutation,
    user: state.admin.user,
    region_districts: state.admin.reg_dst,
    confirmed: state.core.confirmed,
    obligatoryUserFields: state.admin.obligatory_user_fields,
    obligatoryEoFields: state.admin.obligatory_eo_fields,
    isUserNameValid: (_state$admin$validati = state.admin.validationFields) === null || _state$admin$validati === void 0 || (_state$admin$validati = _state$admin$validati.username) === null || _state$admin$validati === void 0 ? void 0 : _state$admin$validati.isValid,
    isUserEmailValid: (_state$admin$validati2 = state.admin.validationFields) === null || _state$admin$validati2 === void 0 || (_state$admin$validati2 = _state$admin$validati2.userEmail) === null || _state$admin$validati2 === void 0 ? void 0 : _state$admin$validati2.isValid,
    usernameLength: (_state$admin = state.admin) === null || _state$admin === void 0 ? void 0 : _state$admin.usernameLength,
    isUserEmailFormatInvalid: (_state$admin$validati3 = state.admin.validationFields) === null || _state$admin$validati3 === void 0 || (_state$admin$validati3 = _state$admin$validati3.userEmailFormat) === null || _state$admin$validati3 === void 0 ? void 0 : _state$admin$validati3.isInvalid
  };
};
var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return redux.bindActionCreators({
    fetchUser: fetchUser,
    createUser: createUser,
    clearUser: clearUser,
    fetchUserMutation: fetchUserMutation,
    fetchRegionDistricts: fetchRegionDistricts,
    fetchObligatoryUserFields: fetchObligatoryUserFields,
    fetchObligatoryEnrolmentOfficerFields: fetchObligatoryEnrolmentOfficerFields,
    fetchUsernameLength: fetchUsernameLength,
    journalize: feCore.journalize,
    coreConfirm: feCore.coreConfirm
  }, dispatch);
};
var UserForm$1 = feCore.withHistory(feCore.withModulesManager(reactRedux.connect(mapStateToProps, mapDispatchToProps)(reactIntl.injectIntl(styles$a.withTheme(styles$a.withStyles(styles$2)(UserForm))))));

var styles$1 = function styles(theme) {
  return {
    page: theme.page
  };
};
var UserPage = function UserPage(props) {
  var modulesManager = props.modulesManager,
    history = props.history,
    match = props.match,
    classes = props.classes;
  var rights = reactRedux.useSelector(function (state) {
    var _state$core$user$i_us, _state$core;
    return (_state$core$user$i_us = (_state$core = state.core) === null || _state$core === void 0 || (_state$core = _state$core.user) === null || _state$core === void 0 || (_state$core = _state$core.i_user) === null || _state$core === void 0 ? void 0 : _state$core.rights) !== null && _state$core$user$i_us !== void 0 ? _state$core$user$i_us : [];
  });
  var _useState = React.useState(Date.now()),
    _useState2 = _slicedToArray__default["default"](_useState, 2),
    resetKey = _useState2[0],
    setResetKey = _useState2[1];
  var _useTranslations = feCore.useTranslations("admin", modulesManager),
    formatMessageWithValues = _useTranslations.formatMessageWithValues;
  var dispatch = reactRedux.useDispatch();
  var add = function add() {
    setResetKey(Date.now());
    feCore.historyPush(modulesManager, history, "admin.userNew");
  };
  var save = function save(user) {
    if (!user.id) {
      dispatch(createUser(modulesManager, user, formatMessageWithValues("user.createUser.mutationLabel")));
    } else {
      dispatch(updateUser(modulesManager, user, formatMessageWithValues("user.updateUser.mutationLabel")));
    }
  };
  return /*#__PURE__*/React__default["default"].createElement("div", {
    className: classes.page
  }, /*#__PURE__*/React__default["default"].createElement(UserForm$1, {
    key: resetKey,
    readOnly: match.params.user_id ? !rights.includes(RIGHT_USER_EDIT) : !rights.includes(RIGHT_USER_ADD),
    userId: match.params.user_id,
    back: function back() {
      return feCore.historyPush(modulesManager, history, "admin.users");
    },
    add: rights.includes(RIGHT_USER_ADD) ? add : null,
    save: rights.includes(RIGHT_USER_EDIT) ? save : null
  }));
};
var enhance = feCore.combine(feCore.withHistory, feCore.withModulesManager, styles$a.withTheme, styles$a.withStyles(styles$1));
var UserPage$1 = enhance(UserPage);

var messagesEn = {
	"admin.UserPicker.label": "User",
	"admin.UserPicker.null": "Any",
	"admin.mainMenu": "Administration",
	"admin.menu.claimAdministrators": "Claim Administrators",
	"admin.menu.enrollmentOfficers": "Enrollment Officers",
	"admin.menu.healthFacilities": "Health Facilities",
	"admin.menu.locations": "Locations",
	"admin.menu.medicalItems": "Medical Items",
	"admin.menu.medicalItemsPrices": "Medical Items Price Lists",
	"admin.menu.medicalServices": "Medical Services",
	"admin.menu.medicalServicesPrices": "Medical Services Price Lists",
	"admin.menu.payers": "Payers",
	"admin.menu.products": "Products",
	"admin.menu.users": "Users",
	"admin.menu.usersProfiles": "Users Profiles",
	"admin.showHistory": "Show historical values",
	"admin.user.CreateUser.mutationLabel": "Create user",
	"admin.user.UserOverview.newTitle": "New User",
	"admin.user.UserOverview.title": "User Details",
	"admin.user.address": "Address",
	"admin.user.addNewUser.tooltip": "Add new user",
	"admin.user.addNewUserTooltip": "Add new user",
	"admin.user.usernameAlreadyTaken": "Username already in use",
	"admin.user.emailAlreadyTaken": "User email already in use",
	"admin.user.emailFormatInvalid": "Invalid email format",
	"admin.user.createUser.mutationLabel": "Create user",
	"admin.user.deleteDialog.message": "Are you sure you want to delete this user?",
	"admin.user.deleteDialog.title": "Delete user",
	"admin.user.deleteDialog.yes.button": "Yes",
	"admin.user.deleteUser.tooltip": "Delete user",
	"admin.user.deleteUserDialog.message": "Are you sure you want to delete this user?",
	"admin.user.dob": "Birth date",
	"admin.user.dobFrom": "Birth date from",
	"admin.user.dobTo": "Birth date to",
	"admin.user.email": "Email",
	"admin.user.districts": "Districts",
	"admin.user.regions": "Regions",
	"admin.user.lastName": "Last name",
	"admin.user.language": "Interface Language",
	"admin.user.openNewTab": "Open in new tab",
	"admin.user.otherNames": "Other names",
	"admin.user.givenNames": "Given names",
	"admin.user.password": "Password",
	"admin.user.newPassword": "New Password",
	"admin.user.confirmNewPassword": "Confirm Password",
	"admin.user.generatePassword": "Generate Password",
	"admin.user.phone": "Phone",
	"admin.user.updateUser.mutationLabel": "Update user",
	"admin.user.userRoles.placeholder": "Select User Role(s)",
	"admin.user.userRoles": "User role(s)",
	"admin.user.userSummaries": "{count} user(s) found",
	"admin.user.userTypes": "User type(s)",
	"admin.user.userTypes.CLAIM_ADMIN": "Claim admin",
	"admin.user.userTypes.INTERACTIVE": "Interactive",
	"admin.user.userTypes.OFFICER": "Enrolment Officer",
	"admin.user.userTypes.noOptions": "No user type found",
	"admin.user.userTypes.none": " ",
	"admin.user.userTypes.null": "Any",
	"admin.user.username": "User name",
	"admin.PaymentPointManagerPicker.placeholder": "Search for an PPM...",
	"admin.PaymentPointManagerPicker.label": "Payment Point Manager",
	"admin.user.worksTo": "Works to",
	"admin.EnrolmentOfficerFormPanel.title": "Enrolment Officer",
	"admin.ClaimAdministratorFormPanel.title": "Claim Administrator",
	"admin.InteractiveUserFormPanel.title": "Interactive User",
	"admin.EnrolmentZonesPicker.table.municipality": "Municipality",
	"admin.EnrolmentZonesPicker.table.newRow": "Add a municipality",
	"admin.EnrolmentZonesPicker.table.villages": "Villages",
	"admin.EnrolmentZonesPicker.table.addButton": "Add a municipality",
	"admin.EnrolmentOfficerFormPanel.substitutionOfficer": "Substitution Officer",
	"admin.EnrolmentOfficerFormPanel.substitutionOfficer.placeholder": "Search for an Officer...",
	"admin.UserPicker.loadingText": "Loading...",
	"admin.UserPicker.clearText": "Clear",
	"admin.UserPicker.openText": "Open",
	"admin.UserPicker.closeText": "Close",
	"admin.UserMasterPanel.loginDetailsTitle": "Login Details",
	"admin.UserMasterPanel.language.null": "Select a language",
	"admin.EnrolmentOfficerPicker.label": "Select an Officer",
	"admin.EnrolmentOfficerPicker.loadingText": "Loading...",
	"admin.EnrolmentOfficerPicker.clearText": "Clear",
	"admin.EnrolmentOfficerPicker.openText": "Open",
	"admin.EnrolmentOfficerPicker.closeText": "Close",
	"admin.UserFilter.showHistory": "Show History",
	"admin.UserFilter.showDeleted": "Show Deleted"
};

var styles = function styles(theme) {
  return {
    label: {
      color: theme.palette.primary.main
    }
  };
};
var UserPicker = function UserPicker(props) {
  var onChange = props.onChange,
    modulesManager = props.modulesManager,
    _props$readOnly = props.readOnly,
    readOnly = _props$readOnly === void 0 ? false : _props$readOnly,
    _props$required = props.required,
    required = _props$required === void 0 ? false : _props$required,
    _props$withLabel = props.withLabel,
    withLabel = _props$withLabel === void 0 ? true : _props$withLabel,
    healthFacility = props.healthFacility,
    _props$filters = props.filters,
    filters = _props$filters === void 0 ? [] : _props$filters,
    value = props.value,
    label = props.label,
    filterOptions = props.filterOptions,
    filterSelectedOptions = props.filterSelectedOptions,
    placeholder = props.placeholder,
    _props$multiple = props.multiple,
    multiple = _props$multiple === void 0 ? false : _props$multiple;
  var minCharLookup = modulesManager.getConf("fe-admin", "usersMinCharLookup", 2);
  var dispatch = reactRedux.useDispatch();
  var _useState = React.useState(null),
    _useState2 = _slicedToArray__default["default"](_useState, 2),
    searchString = _useState2[0],
    setSearchString = _useState2[1];
  var _useTranslations = feCore.useTranslations("admin.UserPicker", modulesManager),
    formatMessage = _useTranslations.formatMessage;
  var _useState3 = React.useState(false),
    _useState4 = _slicedToArray__default["default"](_useState3, 2),
    open = _useState4[0],
    setOpen = _useState4[1];
  var users = reactRedux.useSelector(function (state) {
    return state.admin.users.items;
  });
  var isLoading = reactRedux.useSelector(function (state) {
    return state.admin.users.isLoading;
  });
  var _onInputChange = feCore.useDebounceCb(setSearchString, modulesManager.getConf("fe-admin", "debounceTime", 400));
  // eslint-disable-next-line no-shadow
  var handleChange = function handleChange(__, value) {
    onChange(value);
    if (!multiple) setOpen(false);
  };
  var formatSuggestion = function formatSuggestion(p) {
    var _p$iUser, _p$iUser2, _p$iUser3, _p$iUser4;
    var renderLastNameFirst = modulesManager.getConf("fe-insuree", "renderLastNameFirst", DEFAULT.RENDER_LAST_NAME_FIRST);
    if (!p) return "?";
    return [p.username, renderLastNameFirst ? (_p$iUser = p.iUser) === null || _p$iUser === void 0 ? void 0 : _p$iUser.lastName : (_p$iUser2 = p.iUser) === null || _p$iUser2 === void 0 ? void 0 : _p$iUser2.otherNames, !renderLastNameFirst ? (_p$iUser3 = p.iUser) === null || _p$iUser3 === void 0 ? void 0 : _p$iUser3.lastName : (_p$iUser4 = p.iUser) === null || _p$iUser4 === void 0 ? void 0 : _p$iUser4.otherNames].filter(Boolean).join(" ");
  };
  React.useEffect(function () {
    if ((searchString === null || searchString === void 0 ? void 0 : searchString.length) > minCharLookup) {
      dispatch(fetchUsers(modulesManager, [searchString && "str: \"".concat(searchString, "\"")].concat(_toConsumableArray__default["default"](filters !== null && filters !== void 0 ? filters : [])).filter(Boolean), !healthFacility));
    }
  }, [searchString]);
  React.useEffect(function () {
    if (open) {
      dispatch(fetchUsers(modulesManager, ["first: 10"].concat(_toConsumableArray__default["default"](filters !== null && filters !== void 0 ? filters : [])), !healthFacility));
    }
  }, [open]);
  return /*#__PURE__*/React__default["default"].createElement(lab.Autocomplete, {
    loadingText: formatMessage("loadingText"),
    openText: formatMessage("openText"),
    closeText: formatMessage("closeText"),
    clearText: formatMessage("clearText"),
    openOnFocus: true,
    multiple: multiple,
    disabled: readOnly,
    options: users,
    loading: isLoading,
    open: open,
    onOpen: function onOpen() {
      return setOpen(true);
    },
    onClose: function onClose() {
      return setOpen(false);
    },
    autoComplete: true,
    value: value,
    getOptionLabel: function getOptionLabel(option) {
      return formatSuggestion(option);
    },
    getOptionSelected: function getOptionSelected(option, v) {
      return option.id === v.id;
    },
    onChange: handleChange,
    filterOptions: filterOptions,
    filterSelectedOptions: filterSelectedOptions,
    onInputChange: function onInputChange(__, query) {
      return _onInputChange(query);
    },
    renderInput: function renderInput(inputProps) {
      return /*#__PURE__*/React__default["default"].createElement(core.TextField, _extends__default["default"]({}, inputProps, {
        variant: "standard",
        required: required,
        label: withLabel && (label || formatMessage("label")),
        placeholder: placeholder
      }));
    }
  });
};
var UserPicker$1 = feCore.withModulesManager(styles$a.withTheme(styles$a.withStyles(styles)(UserPicker)));

var EnrolmentOfficerPicker = function EnrolmentOfficerPicker(props) {
  var onChange = props.onChange,
    modulesManager = props.modulesManager,
    _props$readOnly = props.readOnly,
    readOnly = _props$readOnly === void 0 ? false : _props$readOnly,
    _props$required = props.required,
    required = _props$required === void 0 ? false : _props$required,
    _props$withLabel = props.withLabel,
    withLabel = _props$withLabel === void 0 ? true : _props$withLabel,
    value = props.value,
    label = props.label,
    filterOptions = props.filterOptions,
    filterSelectedOptions = props.filterSelectedOptions,
    placeholder = props.placeholder,
    _props$multiple = props.multiple,
    multiple = _props$multiple === void 0 ? false : _props$multiple;
  var dispatch = reactRedux.useDispatch();
  var _useState = React.useState(null),
    _useState2 = _slicedToArray__default["default"](_useState, 2),
    searchString = _useState2[0],
    setSearchString = _useState2[1];
  var isLoading = reactRedux.useSelector(function (state) {
    return state.admin.enrolmentOfficers.isFetching;
  });
  var options = reactRedux.useSelector(function (state) {
    return state.admin.enrolmentOfficers.items;
  });
  React.useEffect(function () {
    dispatch(fetchEnrolmentOfficers(modulesManager, {
      first: searchString ? undefined : 10,
      searchString: searchString
    }));
  }, [searchString]);
  var formatSuggestion = function formatSuggestion(p) {
    var renderLastNameFirst = modulesManager.getConf("fe-insuree", "renderLastNameFirst", DEFAULT.RENDER_LAST_NAME_FIRST);
    if (!p) return "?";
    return [p.username, renderLastNameFirst ? p.lastName : p.otherNames, !renderLastNameFirst ? p.lastName : p.otherNames].filter(Boolean).join(" ");
  };
  return /*#__PURE__*/React__default["default"].createElement(feCore.Autocomplete, {
    multiple: multiple,
    required: required,
    placeholder: placeholder,
    label: label,
    withLabel: withLabel,
    readOnly: readOnly,
    options: options,
    isLoading: isLoading,
    value: value,
    getOptionLabel: formatSuggestion,
    onChange: onChange,
    filterOptions: filterOptions,
    filterSelectedOptions: filterSelectedOptions,
    onInputChange: setSearchString
  });
};
var EnrolmentOfficerPicker$1 = feCore.withModulesManager(EnrolmentOfficerPicker);

var SubstitutionEnrolmentOfficerPicker = function SubstitutionEnrolmentOfficerPicker(props) {
  var _useSelector2;
  var onChange = props.onChange,
    modulesManager = props.modulesManager,
    _props$readOnly = props.readOnly,
    readOnly = _props$readOnly === void 0 ? false : _props$readOnly,
    _props$required = props.required,
    required = _props$required === void 0 ? false : _props$required,
    value = props.value,
    villages = props.villages,
    filterOptions = props.filterOptions,
    filterSelectedOptions = props.filterSelectedOptions,
    _props$multiple = props.multiple,
    multiple = _props$multiple === void 0 ? false : _props$multiple,
    _props$withLabel = props.withLabel,
    withLabel = _props$withLabel === void 0 ? true : _props$withLabel,
    label = props.label,
    _props$withPlaceholde = props.withPlaceholder,
    withPlaceholder = _props$withPlaceholde === void 0 ? false : _props$withPlaceholde,
    placeholder = props.placeholder;
  var dispatch = reactRedux.useDispatch();
  var _useTranslations = feCore.useTranslations("admin", modulesManager),
    formatMessage = _useTranslations.formatMessage;
  var _useState = React.useState(""),
    _useState2 = _slicedToArray__default["default"](_useState, 2),
    searchString = _useState2[0],
    setSearchString = _useState2[1];
  var _useSelector = reactRedux.useSelector(function (state) {
      return state.admin.substitutionEnrolmentOfficers;
    }),
    isFetching = _useSelector.isFetching,
    items = _useSelector.items;
  var officerUuid = (_useSelector2 = reactRedux.useSelector(function (state) {
    var _state$admin;
    return (_state$admin = state.admin) === null || _state$admin === void 0 || (_state$admin = _state$admin.user) === null || _state$admin === void 0 || (_state$admin = _state$admin.officer) === null || _state$admin === void 0 ? void 0 : _state$admin.uuid;
  })) !== null && _useSelector2 !== void 0 ? _useSelector2 : null;
  var handleInputChange = function handleInputChange(str) {
    setSearchString(str);
    fetchSubstitutionEOs(dispatch, modulesManager, officerUuid, searchString, villages);
  };
  var formatSuggestion = function formatSuggestion(p) {
    var renderLastNameFirst = modulesManager.getConf("fe-insuree", "renderLastNameFirst", DEFAULT.RENDER_LAST_NAME_FIRST);
    if (!p) return "?";
    return [p.username, renderLastNameFirst ? p.lastName : p.otherNames, !renderLastNameFirst ? p.lastName : p.otherNames].filter(Boolean).join(" ");
  };
  return /*#__PURE__*/React__default["default"].createElement(feCore.Autocomplete, {
    multiple: multiple,
    required: required,
    placeholder: placeholder,
    label: label,
    withLabel: withLabel,
    readOnly: readOnly,
    options: items,
    isLoading: isFetching,
    value: value,
    getOptionLabel: formatSuggestion,
    onChange: onChange,
    filterOptions: filterOptions,
    filterSelectedOptions: filterSelectedOptions,
    onInputChange: handleInputChange,
    renderInput: function renderInput(inputProps) {
      return /*#__PURE__*/React__default["default"].createElement(core.TextField, _extends__default["default"]({}, inputProps, {
        label: withLabel && (label || formatMessage("EnrolmentOfficerFormPanel.substitutionOfficer")),
        placeholder: withPlaceholder && (placeholder || formatMessage("EnrolmentOfficerFormPanel.substitutionOfficer.placeholder"))
      }));
    }
  });
};
var SubstitutionEnrolmentOfficerPicker$1 = feCore.withModulesManager(SubstitutionEnrolmentOfficerPicker);

var UserRolesPicker = function UserRolesPicker(_ref) {
  var _data$role$edges$map, _data$role;
  var readOnly = _ref.readOnly,
    value = _ref.value,
    _onChange = _ref.onChange,
    required = _ref.required,
    _ref$multiple = _ref.multiple,
    multiple = _ref$multiple === void 0 ? true : _ref$multiple,
    placeholder = _ref.placeholder,
    withLabel = _ref.withLabel,
    withPlaceholder = _ref.withPlaceholder,
    label = _ref.label,
    filterOptions = _ref.filterOptions,
    filterSelectedOptions = _ref.filterSelectedOptions;
  var _useState = React.useState(),
    _useState2 = _slicedToArray__default["default"](_useState, 2),
    searchString = _useState2[0],
    setSearchString = _useState2[1];
  var _useTranslations = feCore.useTranslations("admin"),
    formatMessage = _useTranslations.formatMessage;
  var _useGraphqlQuery = feCore.useGraphqlQuery("\n    query UserRolesPicker ($str: String) {\n      role(str: $str) {\n        edges {\n          node {\n            id name isSystem\n          }\n        }\n      }\n    }\n  ", {
      str: searchString
    }),
    isLoading = _useGraphqlQuery.isLoading,
    data = _useGraphqlQuery.data,
    error = _useGraphqlQuery.error;
  var roles = (_data$role$edges$map = data === null || data === void 0 || (_data$role = data.role) === null || _data$role === void 0 ? void 0 : _data$role.edges.map(function (edge) {
    return edge.node;
  })) !== null && _data$role$edges$map !== void 0 ? _data$role$edges$map : [];
  var uniqueValues = _toConsumableArray__default["default"](new Map(value === null || value === void 0 ? void 0 : value.map(function (role) {
    return [role.id, role];
  })).values());
  return /*#__PURE__*/React__default["default"].createElement(feCore.Autocomplete, {
    multiple: multiple,
    required: required,
    placeholder: placeholder !== null && placeholder !== void 0 ? placeholder : formatMessage("user.userRoles.placeholder"),
    label: label !== null && label !== void 0 ? label : formatMessage("user.userRoles"),
    error: error,
    withLabel: withLabel,
    withPlaceholder: withPlaceholder,
    readOnly: readOnly,
    options: roles,
    isLoading: isLoading,
    value: uniqueValues,
    getOptionLabel: function getOptionLabel(o) {
      return o === null || o === void 0 ? void 0 : o.name;
    },
    onChange: function onChange(option) {
      return _onChange(option, option === null || option === void 0 ? void 0 : option.name);
    },
    filterOptions: filterOptions,
    filterSelectedOptions: filterSelectedOptions,
    onInputChange: function onInputChange() {
      return setSearchString(searchString);
    }
  });
};

var UserTypesPicker = function UserTypesPicker(props) {
  var intl = reactIntl.useIntl();
  var rights = reactRedux.useSelector(function (state) {
    return !!state.core && !!state.core.user && !!state.core.user.i_user ? state.core.user.i_user.rights : [];
  });
  var options = USER_TYPES(rights).map(function (ut) {
    return {
      id: ut,
      label: feCore.formatMessage(intl, "admin.user", "userTypes.".concat(ut))
    };
  });
  var value = [];
  if (props.value) {
    props.value.forEach(function (v) {
      var fullValue = options.find(function (o) {
        return o.id === v;
      });
      if (fullValue) {
        value.push(fullValue);
      }
    });
  }
  return /*#__PURE__*/React__default["default"].createElement(Autocomplete__default["default"], {
    multiple: true,
    noOptionsText: feCore.formatMessage(intl, "admin.user", "userTypes.noOptions"),
    disabled: props.readOnly,
    id: "user-types-select",
    options: options,
    getOptionLabel: function getOptionLabel(option) {
      return option.label;
    },
    onChange: function onChange(e, userTypes) {
      return props.onChange(userTypes.map(function (ut) {
        return ut.id;
      }));
    },
    renderInput: function renderInput(params) {
      return /*#__PURE__*/React__default["default"].createElement(TextField__default["default"], _extends__default["default"]({}, params, {
        variant: "standard",
        label: "".concat(feCore.formatMessage(intl, "admin.user", "userTypes")).concat(props.required ? "*" : ""),
        placeholder: ""
      }));
    },
    value: value
  });
};

function PaymentPointManagerPicker(_ref) {
  var _data$users$edges$map, _data$users;
  var readOnly = _ref.readOnly,
    value = _ref.value,
    _onChange = _ref.onChange,
    required = _ref.required,
    withLabel = _ref.withLabel,
    withPlaceholder = _ref.withPlaceholder,
    filterOptions = _ref.filterOptions,
    filterSelectedOptions = _ref.filterSelectedOptions;
  var _useState = React.useState(),
    _useState2 = _slicedToArray__default["default"](_useState, 2),
    searchString = _useState2[0],
    setSearchString = _useState2[1];
  var _useTranslations = feCore.useTranslations("admin"),
    formatMessage = _useTranslations.formatMessage;

  // Note: IMIS Administrator covers all Payment Point Manager permissions
  var paymentPointManagerRoleId = 7;
  var formatSuggestion = function formatSuggestion(ppm) {
    var _ppm$iUser, _ppm$iUser2;
    return [ppm === null || ppm === void 0 ? void 0 : ppm.username, ppm === null || ppm === void 0 || (_ppm$iUser = ppm.iUser) === null || _ppm$iUser === void 0 ? void 0 : _ppm$iUser.lastName, ppm === null || ppm === void 0 || (_ppm$iUser2 = ppm.iUser) === null || _ppm$iUser2 === void 0 ? void 0 : _ppm$iUser2.otherNames].filter(Boolean).join(" ");
  };
  var _useGraphqlQuery = feCore.useGraphqlQuery("\n    query paymentPointManager($searchString: String, $roleId: Int) {\n        users(str: $searchString, roleId: $roleId) {\n          edges {\n            node {\n              ".concat(USER_PICKER_PROJECTION.join(" "), "\n            }\n          }\n        }\n      }\n    "), {
      str: searchString,
      roleId: paymentPointManagerRoleId
    }),
    isLoading = _useGraphqlQuery.isLoading,
    data = _useGraphqlQuery.data,
    error = _useGraphqlQuery.error;
  var paymentPointManagers = (_data$users$edges$map = data === null || data === void 0 || (_data$users = data.users) === null || _data$users === void 0 ? void 0 : _data$users.edges.map(function (edge) {
    return edge.node;
  })) !== null && _data$users$edges$map !== void 0 ? _data$users$edges$map : [];
  return /*#__PURE__*/React__default["default"].createElement(feCore.Autocomplete, {
    withLabel: withLabel,
    withPlaceholder: withPlaceholder,
    readOnly: readOnly,
    value: value,
    placeholder: formatMessage("PaymentPointManagerPicker.placeholder"),
    label: formatMessage("PaymentPointManagerPicker.label"),
    isLoading: isLoading,
    options: paymentPointManagers,
    error: error,
    getOptionLabel: function getOptionLabel(option) {
      return formatSuggestion(option);
    },
    onChange: function onChange(user) {
      return _onChange(user);
    },
    filterOptions: filterOptions,
    filterSelectedOptions: filterSelectedOptions,
    onInputChange: function onInputChange() {
      return setSearchString(searchString);
    },
    renderInput: function renderInput(inputProps) {
      return /*#__PURE__*/React__default["default"].createElement(core.TextField, _extends__default["default"]({}, inputProps, {
        variant: "standard",
        required: required,
        label: withLabel && formatMessage("PaymentPointManagerPicker.label"),
        placeholder: withPlaceholder && formatMessage("PaymentPointManagerPicker.placeholder")
      }));
    }
  });
}

function ownKeys$1(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$1(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$1(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$1(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function reducer() {
  var _action$payload, _action$payload2, _action$payload3;
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
    enrolmentOfficers: {
      items: [],
      isFetching: false,
      pageInfo: {
        totalCount: 0
      },
      error: null
    },
    substitutionEnrolmentOfficers: {
      items: [],
      isFetching: false,
      pageInfo: {
        totalCount: 0
      },
      error: null
    },
    usersSummaries: {
      items: [],
      isFetching: false,
      isFetched: false,
      fetched: null,
      pageInfo: {
        totalCount: 0
      },
      error: null
    },
    users: {
      items: [],
      isFetching: false,
      isFetched: false,
      error: null
    },
    fetchingUser: false,
    fetchedUser: false,
    errorUser: null,
    user: null,
    submittingMutation: false,
    mutation: {},
    reg_dst: [],
    dst_mun_vil: [],
    obligatory_user_fields: {},
    obligatory_eo_fields: {}
  };
  var action = arguments.length > 1 ? arguments[1] : undefined;
  switch (action.type) {
    case "ADMIN_ENROLMENT_OFFICERS_REQ":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        enrolmentOfficers: _objectSpread$1(_objectSpread$1({}, state.enrolmentOfficers), {}, {
          isFetching: true
        })
      });
    case "ADMIN_ENROLMENT_OFFICERS_RESP":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        enrolmentOfficers: _objectSpread$1(_objectSpread$1({}, state.enrolmentOfficers), {}, {
          isFetching: false,
          pageInfo: feCore.pageInfo(action.payload.data.enrolmentOfficers),
          items: feCore.parseData(action.payload.data.enrolmentOfficers)
        })
      });
    case "ADMIN_ENROLMENT_OFFICERS_ERR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        enrolmentOfficers: _objectSpread$1(_objectSpread$1({}, state.enrolmentOfficers), {}, {
          isFetching: false,
          error: feCore.formatGraphQLError(action.payload)
        })
      });
    case "ADMIN_SUBSTITUTION_ENROLMENT_OFFICERS_REQ":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        substitutionEnrolmentOfficers: _objectSpread$1(_objectSpread$1({}, state.substitutionEnrolmentOfficers), {}, {
          isFetching: true
        })
      });
    case "ADMIN_SUBSTITUTION_ENROLMENT_OFFICERS_RESP":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        substitutionEnrolmentOfficers: _objectSpread$1(_objectSpread$1({}, state.substitutionEnrolmentOfficers), {}, {
          isFetching: false,
          pageInfo: feCore.pageInfo(action.payload.data.substitutionEnrolmentOfficers),
          items: feCore.parseData(action.payload.data.substitutionEnrolmentOfficers)
        })
      });
    case "ADMIN_SUBSTITUTION_ENROLMENT_OFFICERS_ERR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        substitutionEnrolmentOfficers: _objectSpread$1(_objectSpread$1({}, state.substitutionEnrolmentOfficers), {}, {
          isFetching: false,
          error: feCore.formatGraphQLError(action.payload)
        })
      });
    case "ADMIN_USERS_REQ":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        users: _objectSpread$1(_objectSpread$1({}, state.users), {}, {
          isFetching: true,
          fetched: null,
          error: null
        })
      });
    case "ADMIN_USERS_RESP":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        users: _objectSpread$1(_objectSpread$1({}, state.users), {}, {
          isFetching: false,
          fetched: action.meta,
          items: feCore.parseData(action.payload.data.users).map(function (user) {
            return _objectSpread$1(_objectSpread$1({}, user), {}, {
              userTypes: checkRolesAndGetUserTypes(user)
            });
          }),
          error: feCore.formatGraphQLError(action.payload)
        })
      });
    case "ADMIN_USERS_ERR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        users: _objectSpread$1(_objectSpread$1({}, state.users), {}, {
          error: feCore.formatServerError(action.payload),
          isFetching: false,
          items: []
        })
      });
    case "ADMIN_USERS_SUMMARIES_REQ":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        usersSummaries: _objectSpread$1(_objectSpread$1({}, state.usersSummaries), {}, {
          isFetching: true,
          isFetched: false,
          error: null
        })
      });
    case "ADMIN_USERS_SUMMARIES_RESP":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        usersSummaries: _objectSpread$1(_objectSpread$1({}, state.usersSummaries), {}, {
          isFetching: false,
          isFetched: true,
          fetched: action.meta,
          pageInfo: feCore.pageInfo(action.payload.data.users),
          items: feCore.parseData(action.payload.data.users),
          error: feCore.formatGraphQLError(action.payload)
        })
      });
    case "ADMIN_USERS_SUMMARIES_ERR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        usersSummaries: _objectSpread$1(_objectSpread$1({}, state.usersSummaries), {}, {
          isFetching: false,
          isFetched: true,
          fetched: null,
          items: [],
          error: feCore.formatGraphQLError(action.payload)
        })
      });
    case "ADMIN_USER_OVERVIEW_REQ":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchingUser: true,
        fetchedUser: false,
        errorUser: null
      });
    case "ADMIN_USER_OVERVIEW_RESP":
      var users = feCore.parseData(action.payload.data.users);
      var user = null;
      if ((users === null || users === void 0 ? void 0 : users.length) > 0) {
        var _users = _slicedToArray__default["default"](users, 1);
        user = _users[0];
        user = mapQueriesUserToStore(user);
      }
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchingUser: false,
        fetchedUser: true,
        user: user,
        errorUser: feCore.formatGraphQLError(action.payload)
      });
    case "ADMIN_USER_OVERVIEW_ERR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchedUser: false,
        errorUser: feCore.formatServerError(action.payload)
      });
    case "ADMIN_USER_OVERVIEW_CLEAR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        isValidating: false,
        isValid: false,
        user: null,
        validationError: null
      });
    case "ADMIN_USER_NEW":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        usersPageInfo: {
          totalCount: 0
        },
        user: null
      });
    case "LOCATION_REGION_DISTRICTS_REQ":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetching_reg_dst: true,
        fetched_reg_dst: false,
        reg_dst: [],
        errorL1s: null
      });
    case "LOCATION_REGION_DISTRICTS_RESP":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetching_reg_dst: false,
        fetfetched_reg_dstchedL1s: true,
        reg_dst: feCore.parseData(action.payload.data.locations || action.payload.data.locationsStr),
        errorL1s: feCore.formatGraphQLError(action.payload)
      });
    case "LOCATION_REGION_DISTRICTS_ERR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetching_reg_dst: false,
        errorL1s: feCore.formatServerError(action.payload)
      });
    case "LOCATION_REGION_DISTRICTS_CLEAR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        reg_dst: []
      });
    case "LOCATION_DISTRICT_DATA_REQ":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchingDistrictMunAndVil: true,
        fetchedDistrictMunAndVil: false,
        errorDistrictMunAndVil: null
      });
    case "LOCATION_DISTRICT_DATA_RESP":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchingDistrictMunAndVil: false,
        fetchedDistrictMunAndVil: true,
        districtMunAndVil: feCore.parseData(action.payload.data.locations || action.payload.data.locationsStr),
        errorDistrictMunAndVil: feCore.formatGraphQLError(action.payload)
      });
    case "LOCATION_DISTRICT_DATA_ERR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchingDistrictMunAndVil: false,
        errorDistrictMunAndVil: feCore.formatServerError(action.payload)
      });
    case "LOCATION_DISTRICT_DATA_CLEAR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        districtMunAndVil: []
      });
    case "OBLIGTORY_USER_FIELDS_REQ":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetching_obligatory_user_fields: true,
        fetched_obligatory_user_fields: false,
        obligatory_user_fields: null,
        errorL1s: null
      });
    case "OBLIGTORY_USER_FIELDS_RESP":
      console.log("USER FILED RESPONSE ", action.payload.data.userObligatoryFields);
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetching_obligatory_user_fields: false,
        fetched_obligatory_user_fields: true,
        obligatory_user_fields: action.payload.data.userObligatoryFields,
        errorL1s: feCore.formatGraphQLError(action.payload)
      });
    case "OBLIGTORY_USER_FIELDS_ERR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetching_obligatory_user_fields: false,
        errorL1s: feCore.formatServerError(action.payload)
      });
    case "OBLIGTORY_EO_FIELDS_REQ":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetching_obligatory_eo_fields: true,
        fetched_obligatory_eo_fields: false,
        obligatory_eo_fields: null,
        errorL1s: null
      });
    case "OBLIGTORY_EO_FIELDS_RESP":
      console.log("EO FILED RESPONSE ", action.payload.data.eoObligatoryFields);
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetching_obligatory_eo_fields: false,
        fetched_obligatory_eo_fields: true,
        obligatory_eo_fields: action.payload.data.eoObligatoryFields,
        errorL1s: feCore.formatGraphQLError(action.payload)
      });
    case "OBLIGTORY_EO_FIELDS_ERR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetching_obligatory_eo_fields: false,
        errorL1s: feCore.formatServerError(action.payload)
      });
    case "USERNAME_FIELDS_VALIDATION_REQ":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        validationFields: _objectSpread$1(_objectSpread$1({}, state.validationFields), {}, {
          username: {
            isValidating: true,
            isValid: false,
            validationError: null
          }
        })
      });
    case "USERNAME_FIELDS_VALIDATION_RESP":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        validationFields: _objectSpread$1(_objectSpread$1({}, state.validationFields), {}, {
          username: {
            isValidating: false,
            isValid: (_action$payload = action.payload) === null || _action$payload === void 0 ? void 0 : _action$payload.data.isValid,
            validationError: feCore.formatGraphQLError(action.payload)
          }
        })
      });
    case "USERNAME_FIELDS_VALIDATION_ERR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        validationFields: _objectSpread$1(_objectSpread$1({}, state.validationFields), {}, {
          username: {
            isValidating: false,
            isValid: false,
            validationError: feCore.formatServerError(action.payload)
          }
        })
      });
    case "USERNAME_FIELDS_VALIDATION_CLEAR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        validationFields: _objectSpread$1(_objectSpread$1({}, state.validationFields), {}, {
          username: {
            isValidating: true,
            isValid: false,
            validationError: null
          }
        })
      });
    case "USERNAME_FIELDS_VALIDATION_SET_VALID":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        validationFields: _objectSpread$1(_objectSpread$1({}, state.validationFields), {}, {
          username: {
            isValidating: false,
            isValid: true,
            validationError: null
          }
        })
      });
    case "USER_EMAIL_FIELDS_VALIDATION_REQ":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        validationFields: _objectSpread$1(_objectSpread$1({}, state.validationFields), {}, {
          userEmail: {
            isValidating: true,
            isValid: false,
            validationError: null
          }
        })
      });
    case "USER_EMAIL_FIELDS_VALIDATION_RESP":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        validationFields: _objectSpread$1(_objectSpread$1({}, state.validationFields), {}, {
          userEmail: {
            isValidating: false,
            isValid: (_action$payload2 = action.payload) === null || _action$payload2 === void 0 ? void 0 : _action$payload2.data.isValid,
            validationError: feCore.formatGraphQLError(action.payload)
          }
        })
      });
    case "USER_EMAIL_FIELDS_VALIDATION_ERR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        validationFields: _objectSpread$1(_objectSpread$1({}, state.validationFields), {}, {
          userEmail: {
            isValidating: false,
            isValid: false,
            validationError: feCore.formatServerError(action.payload)
          }
        })
      });
    case "USER_EMAIL_FIELDS_VALIDATION_CLEAR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        validationFields: _objectSpread$1(_objectSpread$1({}, state.validationFields), {}, {
          userEmail: {
            isValidating: true,
            isValid: false,
            validationError: null
          }
        })
      });
    case "USER_EMAIL_FIELDS_VALIDATION_SET_VALID":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        validationFields: _objectSpread$1(_objectSpread$1({}, state.validationFields), {}, {
          userEmail: {
            isValidating: false,
            isValid: true,
            validationError: null
          }
        })
      });
    case "USER_EMAIL_FORMAT_VALIDATION_CHECK":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        validationFields: _objectSpread$1(_objectSpread$1({}, state.validationFields), {}, {
          userEmailFormat: {
            isInvalid: (_action$payload3 = action.payload) === null || _action$payload3 === void 0 || (_action$payload3 = _action$payload3.data) === null || _action$payload3 === void 0 ? void 0 : _action$payload3.isFormatInvalid
          }
        })
      });
    case "USERNAME_LENGTH_FIELDS_REQ":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchingUsernameLength: true,
        fetchedUsernameLength: false,
        usernameLength: null,
        errorUsernameLength: null
      });
    case "USERNAME_LENGTH_FIELDS_RESP":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchingUsernameLength: false,
        fetchedUsernameLength: true,
        usernameLength: action.payload.data.usernameLength,
        errorUsernameLength: feCore.formatGraphQLError(action.payload)
      });
    case "USERNAME_LENGTH_FIELDS_ERR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchingUsernameLength: false,
        errorUsernameLength: feCore.formatServerError(action.payload)
      });
    case "ADMIN_USER_MUTATION_REQ":
      return feCore.dispatchMutationReq(state, action);
    case "ADMIN_USER_MUTATION_ERR":
      return feCore.dispatchMutationErr(state, action);
    case "ADMIN_USER_UPDATE_RESP":
      return feCore.dispatchMutationResp(state, "updateUser", action);
    case "ADMIN_USER_DELETE_RESP":
      return feCore.dispatchMutationResp(state, "deleteUser", action);
    case "ADMIN_USER_CREATE_RESP":
      return feCore.dispatchMutationResp(state, "createUser", action);
    default:
      return state;
  }
}

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var ROUTE_ADMIN_USERS = "admin/users";
var ROUTE_ADMIN_USER_OVERVIEW = "admin/users/overview";
var ROUTE_ADMIN_USER_NEW = "admin/users/new";
var DEFAULT_CONFIG = {
  translations: [{
    key: "en",
    messages: messagesEn
  }],
  reducers: [{
    key: "admin",
    reducer: reducer
  }],
  "core.Router": [{
    path: ROUTE_ADMIN_USERS,
    component: UsersPage$1
  }, {
    path: ROUTE_ADMIN_USER_NEW,
    component: UserPage$1
  }, {
    path: "".concat(ROUTE_ADMIN_USER_OVERVIEW, "/:user_id"),
    component: UserPage$1
  }],
  "core.MainMenu": [AdminMainMenu$1],
  refs: [{
    key: "admin.UserPicker",
    ref: UserPicker$1
  }, {
    key: "admin.EnrolmentOfficerPicker",
    ref: EnrolmentOfficerPicker$1
  }, {
    key: "admin.SubstitutionEnrolmentOfficerPicker",
    ref: SubstitutionEnrolmentOfficerPicker$1
  }, {
    key: "admin.UserRolesPicker",
    ref: UserRolesPicker
  }, {
    key: "admin.UserTypesPicker",
    ref: UserTypesPicker
  }, {
    key: "admin.UserPicker.projection",
    ref: USER_PICKER_PROJECTION
  }, {
    key: "admin.users",
    ref: ROUTE_ADMIN_USERS
  }, {
    key: "admin.userOverview",
    ref: ROUTE_ADMIN_USER_OVERVIEW
  }, {
    key: "admin.userNew",
    ref: ROUTE_ADMIN_USER_NEW
  }, {
    key: "admin.PaymentPointManagerPicker",
    ref: PaymentPointManagerPicker
  }],
  "invoice.SubjectAndThirdpartyPicker": [{
    type: "user",
    picker: UserPicker$1,
    pickerProjection: USER_PICKER_PROJECTION
  }]
};
var AdminModule = function AdminModule(cfg) {
  return _objectSpread(_objectSpread({}, DEFAULT_CONFIG), cfg);
};

exports.AdminModule = AdminModule;
//# sourceMappingURL=index.js.map
